<?php

/**
 * This code was generated by
 * ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
 *  |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
 *  |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \
 *
 * Twilio - Api
 * This is the public Twilio REST API.
 *
 * NOTE: This class is auto generated by OpenAPI Generator.
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
namespace ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account;

use ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException;
use ShopMagicTwilioVendor\Twilio\ListResource;
use ShopMagicTwilioVendor\Twilio\Version;
use ShopMagicTwilioVendor\Twilio\InstanceContext;
use ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\AvailablePhoneNumberCountry\VoipList;
use ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\AvailablePhoneNumberCountry\NationalList;
use ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\AvailablePhoneNumberCountry\MobileList;
use ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\AvailablePhoneNumberCountry\MachineToMachineList;
use ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\AvailablePhoneNumberCountry\TollFreeList;
use ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\AvailablePhoneNumberCountry\SharedCostList;
use ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\AvailablePhoneNumberCountry\LocalList;
/**
 * @property VoipList $voip
 * @property NationalList $national
 * @property MobileList $mobile
 * @property MachineToMachineList $machineToMachine
 * @property TollFreeList $tollFree
 * @property SharedCostList $sharedCost
 * @property LocalList $local
 */
class AvailablePhoneNumberCountryContext extends \ShopMagicTwilioVendor\Twilio\InstanceContext
{
    protected $_voip;
    protected $_national;
    protected $_mobile;
    protected $_machineToMachine;
    protected $_tollFree;
    protected $_sharedCost;
    protected $_local;
    /**
     * Initialize the AvailablePhoneNumberCountryContext
     *
     * @param Version $version Version that contains the resource
     * @param string $accountSid The SID of the [Account](https://www.twilio.com/docs/iam/api/account) requesting the available phone number Country resource.
     * @param string $countryCode The [ISO-3166-1](https://en.wikipedia.org/wiki/ISO_3166-1_alpha-2) country code of the country to fetch available phone number information about.
     */
    public function __construct(\ShopMagicTwilioVendor\Twilio\Version $version, $accountSid, $countryCode)
    {
        parent::__construct($version);
        // Path Solution
        $this->solution = ['accountSid' => $accountSid, 'countryCode' => $countryCode];
        $this->uri = '/Accounts/' . \rawurlencode($accountSid) . '/AvailablePhoneNumbers/' . \rawurlencode($countryCode) . '.json';
    }
    /**
     * Fetch the AvailablePhoneNumberCountryInstance
     *
     * @return AvailablePhoneNumberCountryInstance Fetched AvailablePhoneNumberCountryInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function fetch() : \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\AvailablePhoneNumberCountryInstance
    {
        $payload = $this->version->fetch('GET', $this->uri);
        return new \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\AvailablePhoneNumberCountryInstance($this->version, $payload, $this->solution['accountSid'], $this->solution['countryCode']);
    }
    /**
     * Access the voip
     */
    protected function getVoip() : \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\AvailablePhoneNumberCountry\VoipList
    {
        if (!$this->_voip) {
            $this->_voip = new \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\AvailablePhoneNumberCountry\VoipList($this->version, $this->solution['accountSid'], $this->solution['countryCode']);
        }
        return $this->_voip;
    }
    /**
     * Access the national
     */
    protected function getNational() : \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\AvailablePhoneNumberCountry\NationalList
    {
        if (!$this->_national) {
            $this->_national = new \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\AvailablePhoneNumberCountry\NationalList($this->version, $this->solution['accountSid'], $this->solution['countryCode']);
        }
        return $this->_national;
    }
    /**
     * Access the mobile
     */
    protected function getMobile() : \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\AvailablePhoneNumberCountry\MobileList
    {
        if (!$this->_mobile) {
            $this->_mobile = new \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\AvailablePhoneNumberCountry\MobileList($this->version, $this->solution['accountSid'], $this->solution['countryCode']);
        }
        return $this->_mobile;
    }
    /**
     * Access the machineToMachine
     */
    protected function getMachineToMachine() : \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\AvailablePhoneNumberCountry\MachineToMachineList
    {
        if (!$this->_machineToMachine) {
            $this->_machineToMachine = new \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\AvailablePhoneNumberCountry\MachineToMachineList($this->version, $this->solution['accountSid'], $this->solution['countryCode']);
        }
        return $this->_machineToMachine;
    }
    /**
     * Access the tollFree
     */
    protected function getTollFree() : \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\AvailablePhoneNumberCountry\TollFreeList
    {
        if (!$this->_tollFree) {
            $this->_tollFree = new \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\AvailablePhoneNumberCountry\TollFreeList($this->version, $this->solution['accountSid'], $this->solution['countryCode']);
        }
        return $this->_tollFree;
    }
    /**
     * Access the sharedCost
     */
    protected function getSharedCost() : \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\AvailablePhoneNumberCountry\SharedCostList
    {
        if (!$this->_sharedCost) {
            $this->_sharedCost = new \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\AvailablePhoneNumberCountry\SharedCostList($this->version, $this->solution['accountSid'], $this->solution['countryCode']);
        }
        return $this->_sharedCost;
    }
    /**
     * Access the local
     */
    protected function getLocal() : \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\AvailablePhoneNumberCountry\LocalList
    {
        if (!$this->_local) {
            $this->_local = new \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\AvailablePhoneNumberCountry\LocalList($this->version, $this->solution['accountSid'], $this->solution['countryCode']);
        }
        return $this->_local;
    }
    /**
     * Magic getter to lazy load subresources
     *
     * @param string $name Subresource to return
     * @return ListResource The requested subresource
     * @throws TwilioException For unknown subresources
     */
    public function __get(string $name) : \ShopMagicTwilioVendor\Twilio\ListResource
    {
        if (\property_exists($this, '_' . $name)) {
            $method = 'get' . \ucfirst($name);
            return $this->{$method}();
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Unknown subresource ' . $name);
    }
    /**
     * Magic caller to get resource contexts
     *
     * @param string $name Resource to return
     * @param array $arguments Context parameters
     * @return InstanceContext The requested resource context
     * @throws TwilioException For unknown resource
     */
    public function __call(string $name, array $arguments) : \ShopMagicTwilioVendor\Twilio\InstanceContext
    {
        $property = $this->{$name};
        if (\method_exists($property, 'getContext')) {
            return \call_user_func_array(array($property, 'getContext'), $arguments);
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Resource does not have a context');
    }
    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString() : string
    {
        $context = [];
        foreach ($this->solution as $key => $value) {
            $context[] = "{$key}={$value}";
        }
        return '[Twilio.Api.V2010.AvailablePhoneNumberCountryContext ' . \implode(' ', $context) . ']';
    }
}
