<?php

/**
 * This code was generated by
 * ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
 *  |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
 *  |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \
 *
 * Twilio - Api
 * This is the public Twilio REST API.
 *
 * NOTE: This class is auto generated by OpenAPI Generator.
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
namespace ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account;

use ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException;
use ShopMagicTwilioVendor\Twilio\InstanceResource;
use ShopMagicTwilioVendor\Twilio\Options;
use ShopMagicTwilioVendor\Twilio\Values;
use ShopMagicTwilioVendor\Twilio\Version;
use ShopMagicTwilioVendor\Twilio\Deserialize;
use ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Call\RecordingList;
use ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Call\UserDefinedMessageSubscriptionList;
use ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Call\EventList;
use ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Call\NotificationList;
use ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Call\UserDefinedMessageList;
use ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Call\SiprecList;
use ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Call\StreamList;
use ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Call\PaymentList;
/**
 * @property string|null $sid
 * @property \DateTime|null $dateCreated
 * @property \DateTime|null $dateUpdated
 * @property string|null $parentCallSid
 * @property string|null $accountSid
 * @property string|null $to
 * @property string|null $toFormatted
 * @property string|null $from
 * @property string|null $fromFormatted
 * @property string|null $phoneNumberSid
 * @property string $status
 * @property \DateTime|null $startTime
 * @property \DateTime|null $endTime
 * @property string|null $duration
 * @property string|null $price
 * @property string|null $priceUnit
 * @property string|null $direction
 * @property string|null $answeredBy
 * @property string|null $apiVersion
 * @property string|null $forwardedFrom
 * @property string|null $groupSid
 * @property string|null $callerName
 * @property string|null $queueTime
 * @property string|null $trunkSid
 * @property string|null $uri
 * @property array|null $subresourceUris
 */
class CallInstance extends \ShopMagicTwilioVendor\Twilio\InstanceResource
{
    protected $_recordings;
    protected $_userDefinedMessageSubscriptions;
    protected $_events;
    protected $_notifications;
    protected $_userDefinedMessages;
    protected $_siprec;
    protected $_streams;
    protected $_payments;
    /**
     * Initialize the CallInstance
     *
     * @param Version $version Version that contains the resource
     * @param mixed[] $payload The response payload
     * @param string $accountSid The SID of the [Account](https://www.twilio.com/docs/iam/api/account) that will create the resource.
     * @param string $sid The Twilio-provided Call SID that uniquely identifies the Call resource to delete
     */
    public function __construct(\ShopMagicTwilioVendor\Twilio\Version $version, array $payload, string $accountSid, string $sid = null)
    {
        parent::__construct($version);
        // Marshaled Properties
        $this->properties = ['sid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'sid'), 'dateCreated' => \ShopMagicTwilioVendor\Twilio\Deserialize::dateTime(\ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'date_created')), 'dateUpdated' => \ShopMagicTwilioVendor\Twilio\Deserialize::dateTime(\ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'date_updated')), 'parentCallSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'parent_call_sid'), 'accountSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'account_sid'), 'to' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'to'), 'toFormatted' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'to_formatted'), 'from' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'from'), 'fromFormatted' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'from_formatted'), 'phoneNumberSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'phone_number_sid'), 'status' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'status'), 'startTime' => \ShopMagicTwilioVendor\Twilio\Deserialize::dateTime(\ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'start_time')), 'endTime' => \ShopMagicTwilioVendor\Twilio\Deserialize::dateTime(\ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'end_time')), 'duration' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'duration'), 'price' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'price'), 'priceUnit' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'price_unit'), 'direction' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'direction'), 'answeredBy' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'answered_by'), 'apiVersion' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'api_version'), 'forwardedFrom' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'forwarded_from'), 'groupSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'group_sid'), 'callerName' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'caller_name'), 'queueTime' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'queue_time'), 'trunkSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'trunk_sid'), 'uri' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'uri'), 'subresourceUris' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'subresource_uris')];
        $this->solution = ['accountSid' => $accountSid, 'sid' => $sid ?: $this->properties['sid']];
    }
    /**
     * Generate an instance context for the instance, the context is capable of
     * performing various actions.  All instance actions are proxied to the context
     *
     * @return CallContext Context for this CallInstance
     */
    protected function proxy() : \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\CallContext
    {
        if (!$this->context) {
            $this->context = new \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\CallContext($this->version, $this->solution['accountSid'], $this->solution['sid']);
        }
        return $this->context;
    }
    /**
     * Delete the CallInstance
     *
     * @return bool True if delete succeeds, false otherwise
     * @throws TwilioException When an HTTP error occurs.
     */
    public function delete() : bool
    {
        return $this->proxy()->delete();
    }
    /**
     * Fetch the CallInstance
     *
     * @return CallInstance Fetched CallInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function fetch() : \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\CallInstance
    {
        return $this->proxy()->fetch();
    }
    /**
     * Update the CallInstance
     *
     * @param array|Options $options Optional Arguments
     * @return CallInstance Updated CallInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function update(array $options = []) : \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\CallInstance
    {
        return $this->proxy()->update($options);
    }
    /**
     * Access the recordings
     */
    protected function getRecordings() : \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Call\RecordingList
    {
        return $this->proxy()->recordings;
    }
    /**
     * Access the userDefinedMessageSubscriptions
     */
    protected function getUserDefinedMessageSubscriptions() : \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Call\UserDefinedMessageSubscriptionList
    {
        return $this->proxy()->userDefinedMessageSubscriptions;
    }
    /**
     * Access the events
     */
    protected function getEvents() : \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Call\EventList
    {
        return $this->proxy()->events;
    }
    /**
     * Access the notifications
     */
    protected function getNotifications() : \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Call\NotificationList
    {
        return $this->proxy()->notifications;
    }
    /**
     * Access the userDefinedMessages
     */
    protected function getUserDefinedMessages() : \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Call\UserDefinedMessageList
    {
        return $this->proxy()->userDefinedMessages;
    }
    /**
     * Access the siprec
     */
    protected function getSiprec() : \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Call\SiprecList
    {
        return $this->proxy()->siprec;
    }
    /**
     * Access the streams
     */
    protected function getStreams() : \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Call\StreamList
    {
        return $this->proxy()->streams;
    }
    /**
     * Access the payments
     */
    protected function getPayments() : \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Call\PaymentList
    {
        return $this->proxy()->payments;
    }
    /**
     * Magic getter to access properties
     *
     * @param string $name Property to access
     * @return mixed The requested property
     * @throws TwilioException For unknown properties
     */
    public function __get(string $name)
    {
        if (\array_key_exists($name, $this->properties)) {
            return $this->properties[$name];
        }
        if (\property_exists($this, '_' . $name)) {
            $method = 'get' . \ucfirst($name);
            return $this->{$method}();
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Unknown property: ' . $name);
    }
    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString() : string
    {
        $context = [];
        foreach ($this->solution as $key => $value) {
            $context[] = "{$key}={$value}";
        }
        return '[Twilio.Api.V2010.CallInstance ' . \implode(' ', $context) . ']';
    }
}
