<?php

/**
 * This code was generated by
 * ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
 *  |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
 *  |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \
 *
 * Twilio - Api
 * This is the public Twilio REST API.
 *
 * NOTE: This class is auto generated by OpenAPI Generator.
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
namespace ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Sip;

use ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException;
use ShopMagicTwilioVendor\Twilio\InstanceResource;
use ShopMagicTwilioVendor\Twilio\Options;
use ShopMagicTwilioVendor\Twilio\Values;
use ShopMagicTwilioVendor\Twilio\Version;
use ShopMagicTwilioVendor\Twilio\Deserialize;
use ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Sip\Domain\CredentialListMappingList;
use ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Sip\Domain\IpAccessControlListMappingList;
use ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Sip\Domain\AuthTypesList;
/**
 * @property string|null $accountSid
 * @property string|null $apiVersion
 * @property string|null $authType
 * @property \DateTime|null $dateCreated
 * @property \DateTime|null $dateUpdated
 * @property string|null $domainName
 * @property string|null $friendlyName
 * @property string|null $sid
 * @property string|null $uri
 * @property string|null $voiceFallbackMethod
 * @property string|null $voiceFallbackUrl
 * @property string|null $voiceMethod
 * @property string|null $voiceStatusCallbackMethod
 * @property string|null $voiceStatusCallbackUrl
 * @property string|null $voiceUrl
 * @property array|null $subresourceUris
 * @property bool|null $sipRegistration
 * @property bool|null $emergencyCallingEnabled
 * @property bool|null $secure
 * @property string|null $byocTrunkSid
 * @property string|null $emergencyCallerSid
 */
class DomainInstance extends \ShopMagicTwilioVendor\Twilio\InstanceResource
{
    protected $_credentialListMappings;
    protected $_ipAccessControlListMappings;
    protected $_auth;
    /**
     * Initialize the DomainInstance
     *
     * @param Version $version Version that contains the resource
     * @param mixed[] $payload The response payload
     * @param string $accountSid The SID of the [Account](https://www.twilio.com/docs/iam/api/account) that will create the resource.
     * @param string $sid The Twilio-provided string that uniquely identifies the SipDomain resource to delete.
     */
    public function __construct(\ShopMagicTwilioVendor\Twilio\Version $version, array $payload, string $accountSid, string $sid = null)
    {
        parent::__construct($version);
        // Marshaled Properties
        $this->properties = ['accountSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'account_sid'), 'apiVersion' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'api_version'), 'authType' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'auth_type'), 'dateCreated' => \ShopMagicTwilioVendor\Twilio\Deserialize::dateTime(\ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'date_created')), 'dateUpdated' => \ShopMagicTwilioVendor\Twilio\Deserialize::dateTime(\ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'date_updated')), 'domainName' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'domain_name'), 'friendlyName' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'friendly_name'), 'sid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'sid'), 'uri' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'uri'), 'voiceFallbackMethod' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'voice_fallback_method'), 'voiceFallbackUrl' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'voice_fallback_url'), 'voiceMethod' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'voice_method'), 'voiceStatusCallbackMethod' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'voice_status_callback_method'), 'voiceStatusCallbackUrl' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'voice_status_callback_url'), 'voiceUrl' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'voice_url'), 'subresourceUris' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'subresource_uris'), 'sipRegistration' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'sip_registration'), 'emergencyCallingEnabled' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'emergency_calling_enabled'), 'secure' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'secure'), 'byocTrunkSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'byoc_trunk_sid'), 'emergencyCallerSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'emergency_caller_sid')];
        $this->solution = ['accountSid' => $accountSid, 'sid' => $sid ?: $this->properties['sid']];
    }
    /**
     * Generate an instance context for the instance, the context is capable of
     * performing various actions.  All instance actions are proxied to the context
     *
     * @return DomainContext Context for this DomainInstance
     */
    protected function proxy() : \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Sip\DomainContext
    {
        if (!$this->context) {
            $this->context = new \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Sip\DomainContext($this->version, $this->solution['accountSid'], $this->solution['sid']);
        }
        return $this->context;
    }
    /**
     * Delete the DomainInstance
     *
     * @return bool True if delete succeeds, false otherwise
     * @throws TwilioException When an HTTP error occurs.
     */
    public function delete() : bool
    {
        return $this->proxy()->delete();
    }
    /**
     * Fetch the DomainInstance
     *
     * @return DomainInstance Fetched DomainInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function fetch() : \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Sip\DomainInstance
    {
        return $this->proxy()->fetch();
    }
    /**
     * Update the DomainInstance
     *
     * @param array|Options $options Optional Arguments
     * @return DomainInstance Updated DomainInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function update(array $options = []) : \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Sip\DomainInstance
    {
        return $this->proxy()->update($options);
    }
    /**
     * Access the credentialListMappings
     */
    protected function getCredentialListMappings() : \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Sip\Domain\CredentialListMappingList
    {
        return $this->proxy()->credentialListMappings;
    }
    /**
     * Access the ipAccessControlListMappings
     */
    protected function getIpAccessControlListMappings() : \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Sip\Domain\IpAccessControlListMappingList
    {
        return $this->proxy()->ipAccessControlListMappings;
    }
    /**
     * Access the auth
     */
    protected function getAuth() : \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Sip\Domain\AuthTypesList
    {
        return $this->proxy()->auth;
    }
    /**
     * Magic getter to access properties
     *
     * @param string $name Property to access
     * @return mixed The requested property
     * @throws TwilioException For unknown properties
     */
    public function __get(string $name)
    {
        if (\array_key_exists($name, $this->properties)) {
            return $this->properties[$name];
        }
        if (\property_exists($this, '_' . $name)) {
            $method = 'get' . \ucfirst($name);
            return $this->{$method}();
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Unknown property: ' . $name);
    }
    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString() : string
    {
        $context = [];
        foreach ($this->solution as $key => $value) {
            $context[] = "{$key}={$value}";
        }
        return '[Twilio.Api.V2010.DomainInstance ' . \implode(' ', $context) . ']';
    }
}
