<?php

/**
 * This code was generated by
 * ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
 *  |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
 *  |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \
 *
 * Twilio - Api
 * This is the public Twilio REST API.
 *
 * NOTE: This class is auto generated by OpenAPI Generator.
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
namespace ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account;

use ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException;
use ShopMagicTwilioVendor\Twilio\ListResource;
use ShopMagicTwilioVendor\Twilio\Version;
use ShopMagicTwilioVendor\Twilio\InstanceContext;
use ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Sip\DomainList;
use ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Sip\CredentialListList;
use ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Sip\IpAccessControlListList;
/**
 * @property DomainList $domains
 * @property CredentialListList $credentialLists
 * @property IpAccessControlListList $ipAccessControlLists
 * @method \Twilio\Rest\Api\V2010\Account\Sip\DomainContext domains(string $sid)
 * @method \Twilio\Rest\Api\V2010\Account\Sip\CredentialListContext credentialLists(string $sid)
 * @method \Twilio\Rest\Api\V2010\Account\Sip\IpAccessControlListContext ipAccessControlLists(string $sid)
 */
class SipList extends \ShopMagicTwilioVendor\Twilio\ListResource
{
    protected $_domains = null;
    protected $_credentialLists = null;
    protected $_ipAccessControlLists = null;
    /**
     * Construct the SipList
     *
     * @param Version $version Version that contains the resource
     * @param string $accountSid The SID of the [Account](https://www.twilio.com/docs/iam/api/account) that created the SipDomain resources to read.
     */
    public function __construct(\ShopMagicTwilioVendor\Twilio\Version $version, string $accountSid)
    {
        parent::__construct($version);
        // Path Solution
        $this->solution = ['accountSid' => $accountSid];
    }
    /**
     * Access the domains
     */
    protected function getDomains() : \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Sip\DomainList
    {
        if (!$this->_domains) {
            $this->_domains = new \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Sip\DomainList($this->version, $this->solution['accountSid']);
        }
        return $this->_domains;
    }
    /**
     * Access the credentialLists
     */
    protected function getCredentialLists() : \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Sip\CredentialListList
    {
        if (!$this->_credentialLists) {
            $this->_credentialLists = new \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Sip\CredentialListList($this->version, $this->solution['accountSid']);
        }
        return $this->_credentialLists;
    }
    /**
     * Access the ipAccessControlLists
     */
    protected function getIpAccessControlLists() : \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Sip\IpAccessControlListList
    {
        if (!$this->_ipAccessControlLists) {
            $this->_ipAccessControlLists = new \ShopMagicTwilioVendor\Twilio\Rest\Api\V2010\Account\Sip\IpAccessControlListList($this->version, $this->solution['accountSid']);
        }
        return $this->_ipAccessControlLists;
    }
    /**
     * Magic getter to lazy load subresources
     *
     * @param string $name Subresource to return
     * @return \Twilio\ListResource The requested subresource
     * @throws TwilioException For unknown subresources
     */
    public function __get(string $name)
    {
        if (\property_exists($this, '_' . $name)) {
            $method = 'get' . \ucfirst($name);
            return $this->{$method}();
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Unknown subresource ' . $name);
    }
    /**
     * Magic caller to get resource contexts
     *
     * @param string $name Resource to return
     * @param array $arguments Context parameters
     * @return InstanceContext The requested resource context
     * @throws TwilioException For unknown resource
     */
    public function __call(string $name, array $arguments) : \ShopMagicTwilioVendor\Twilio\InstanceContext
    {
        $property = $this->{$name};
        if (\method_exists($property, 'getContext')) {
            return \call_user_func_array(array($property, 'getContext'), $arguments);
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Resource does not have a context');
    }
    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString() : string
    {
        return '[Twilio.Api.V2010.SipList]';
    }
}
