<?php

/**
 * This code was generated by
 * ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
 *  |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
 *  |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \
 *
 * Twilio - Bulkexports
 * This is the public Twilio REST API.
 *
 * NOTE: This class is auto generated by OpenAPI Generator.
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
namespace ShopMagicTwilioVendor\Twilio\Rest\Bulkexports\V1\Export;

use ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException;
use ShopMagicTwilioVendor\Twilio\InstanceResource;
use ShopMagicTwilioVendor\Twilio\Values;
use ShopMagicTwilioVendor\Twilio\Version;
/**
 * @property string|null $resourceType
 * @property string|null $friendlyName
 * @property array|null $details
 * @property string|null $startDay
 * @property string|null $endDay
 * @property string|null $jobSid
 * @property string|null $webhookUrl
 * @property string|null $webhookMethod
 * @property string|null $email
 * @property string|null $url
 * @property string|null $jobQueuePosition
 * @property string|null $estimatedCompletionTime
 */
class JobInstance extends \ShopMagicTwilioVendor\Twilio\InstanceResource
{
    /**
     * Initialize the JobInstance
     *
     * @param Version $version Version that contains the resource
     * @param mixed[] $payload The response payload
     * @param string $jobSid The unique string that that we created to identify the Bulk Export job
     */
    public function __construct(\ShopMagicTwilioVendor\Twilio\Version $version, array $payload, string $jobSid = null)
    {
        parent::__construct($version);
        // Marshaled Properties
        $this->properties = ['resourceType' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'resource_type'), 'friendlyName' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'friendly_name'), 'details' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'details'), 'startDay' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'start_day'), 'endDay' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'end_day'), 'jobSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'job_sid'), 'webhookUrl' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'webhook_url'), 'webhookMethod' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'webhook_method'), 'email' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'email'), 'url' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'url'), 'jobQueuePosition' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'job_queue_position'), 'estimatedCompletionTime' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'estimated_completion_time')];
        $this->solution = ['jobSid' => $jobSid ?: $this->properties['jobSid']];
    }
    /**
     * Generate an instance context for the instance, the context is capable of
     * performing various actions.  All instance actions are proxied to the context
     *
     * @return JobContext Context for this JobInstance
     */
    protected function proxy() : \ShopMagicTwilioVendor\Twilio\Rest\Bulkexports\V1\Export\JobContext
    {
        if (!$this->context) {
            $this->context = new \ShopMagicTwilioVendor\Twilio\Rest\Bulkexports\V1\Export\JobContext($this->version, $this->solution['jobSid']);
        }
        return $this->context;
    }
    /**
     * Delete the JobInstance
     *
     * @return bool True if delete succeeds, false otherwise
     * @throws TwilioException When an HTTP error occurs.
     */
    public function delete() : bool
    {
        return $this->proxy()->delete();
    }
    /**
     * Fetch the JobInstance
     *
     * @return JobInstance Fetched JobInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function fetch() : \ShopMagicTwilioVendor\Twilio\Rest\Bulkexports\V1\Export\JobInstance
    {
        return $this->proxy()->fetch();
    }
    /**
     * Magic getter to access properties
     *
     * @param string $name Property to access
     * @return mixed The requested property
     * @throws TwilioException For unknown properties
     */
    public function __get(string $name)
    {
        if (\array_key_exists($name, $this->properties)) {
            return $this->properties[$name];
        }
        if (\property_exists($this, '_' . $name)) {
            $method = 'get' . \ucfirst($name);
            return $this->{$method}();
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Unknown property: ' . $name);
    }
    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString() : string
    {
        $context = [];
        foreach ($this->solution as $key => $value) {
            $context[] = "{$key}={$value}";
        }
        return '[Twilio.Bulkexports.V1.JobInstance ' . \implode(' ', $context) . ']';
    }
}
