<?php

/**
 * This code was generated by
 * ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
 *  |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
 *  |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \
 *
 * Twilio - Conversations
 * This is the public Twilio REST API.
 *
 * NOTE: This class is auto generated by OpenAPI Generator.
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
namespace ShopMagicTwilioVendor\Twilio\Rest\Conversations\V1\Service;

use ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException;
use ShopMagicTwilioVendor\Twilio\ListResource;
use ShopMagicTwilioVendor\Twilio\Version;
use ShopMagicTwilioVendor\Twilio\InstanceContext;
use ShopMagicTwilioVendor\Twilio\Rest\Conversations\V1\Service\Configuration\NotificationList;
use ShopMagicTwilioVendor\Twilio\Rest\Conversations\V1\Service\Configuration\WebhookList;
/**
 * @property NotificationList $notifications
 * @property WebhookList $webhooks
 * @method \Twilio\Rest\Conversations\V1\Service\Configuration\NotificationContext notifications()
 * @method \Twilio\Rest\Conversations\V1\Service\Configuration\WebhookContext webhooks()
 */
class ConfigurationList extends \ShopMagicTwilioVendor\Twilio\ListResource
{
    protected $_notifications = null;
    protected $_webhooks = null;
    /**
     * Construct the ConfigurationList
     *
     * @param Version $version Version that contains the resource
     * @param string $chatServiceSid The SID of the Service configuration resource to fetch.
     */
    public function __construct(\ShopMagicTwilioVendor\Twilio\Version $version, string $chatServiceSid)
    {
        parent::__construct($version);
        // Path Solution
        $this->solution = ['chatServiceSid' => $chatServiceSid];
    }
    /**
     * Constructs a ConfigurationContext
     */
    public function getContext() : \ShopMagicTwilioVendor\Twilio\Rest\Conversations\V1\Service\ConfigurationContext
    {
        return new \ShopMagicTwilioVendor\Twilio\Rest\Conversations\V1\Service\ConfigurationContext($this->version, $this->solution['chatServiceSid']);
    }
    /**
     * Access the notifications
     */
    protected function getNotifications() : \ShopMagicTwilioVendor\Twilio\Rest\Conversations\V1\Service\Configuration\NotificationList
    {
        if (!$this->_notifications) {
            $this->_notifications = new \ShopMagicTwilioVendor\Twilio\Rest\Conversations\V1\Service\Configuration\NotificationList($this->version, $this->solution['chatServiceSid']);
        }
        return $this->_notifications;
    }
    /**
     * Access the webhooks
     */
    protected function getWebhooks() : \ShopMagicTwilioVendor\Twilio\Rest\Conversations\V1\Service\Configuration\WebhookList
    {
        if (!$this->_webhooks) {
            $this->_webhooks = new \ShopMagicTwilioVendor\Twilio\Rest\Conversations\V1\Service\Configuration\WebhookList($this->version, $this->solution['chatServiceSid']);
        }
        return $this->_webhooks;
    }
    /**
     * Magic getter to lazy load subresources
     *
     * @param string $name Subresource to return
     * @return \Twilio\ListResource The requested subresource
     * @throws TwilioException For unknown subresources
     */
    public function __get(string $name)
    {
        if (\property_exists($this, '_' . $name)) {
            $method = 'get' . \ucfirst($name);
            return $this->{$method}();
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Unknown subresource ' . $name);
    }
    /**
     * Magic caller to get resource contexts
     *
     * @param string $name Resource to return
     * @param array $arguments Context parameters
     * @return InstanceContext The requested resource context
     * @throws TwilioException For unknown resource
     */
    public function __call(string $name, array $arguments) : \ShopMagicTwilioVendor\Twilio\InstanceContext
    {
        $property = $this->{$name};
        if (\method_exists($property, 'getContext')) {
            return \call_user_func_array(array($property, 'getContext'), $arguments);
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Resource does not have a context');
    }
    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString() : string
    {
        return '[Twilio.Conversations.V1.ConfigurationList]';
    }
}
