<?php

/**
 * This code was generated by
 * ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
 *  |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
 *  |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \
 *
 * Twilio - Flex
 * This is the public Twilio REST API.
 *
 * NOTE: This class is auto generated by OpenAPI Generator.
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
namespace ShopMagicTwilioVendor\Twilio\Rest\FlexApi\V1;

use ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException;
use ShopMagicTwilioVendor\Twilio\Options;
use ShopMagicTwilioVendor\Twilio\Values;
use ShopMagicTwilioVendor\Twilio\Version;
use ShopMagicTwilioVendor\Twilio\InstanceContext;
class AssessmentsContext extends \ShopMagicTwilioVendor\Twilio\InstanceContext
{
    /**
     * Initialize the AssessmentsContext
     *
     * @param Version $version Version that contains the resource
     * @param string $assessmentSid The SID of the assessment to be modified
     */
    public function __construct(\ShopMagicTwilioVendor\Twilio\Version $version, $assessmentSid)
    {
        parent::__construct($version);
        // Path Solution
        $this->solution = ['assessmentSid' => $assessmentSid];
        $this->uri = '/Insights/QualityManagement/Assessments/' . \rawurlencode($assessmentSid) . '';
    }
    /**
     * Update the AssessmentsInstance
     *
     * @param string $offset The offset of the conversation
     * @param string $answerText The answer text selected by user
     * @param string $answerId The id of the answer selected by user
     * @param array|Options $options Optional Arguments
     * @return AssessmentsInstance Updated AssessmentsInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function update(string $offset, string $answerText, string $answerId, array $options = []) : \ShopMagicTwilioVendor\Twilio\Rest\FlexApi\V1\AssessmentsInstance
    {
        $options = new \ShopMagicTwilioVendor\Twilio\Values($options);
        $data = \ShopMagicTwilioVendor\Twilio\Values::of(['Offset' => $offset, 'AnswerText' => $answerText, 'AnswerId' => $answerId]);
        $headers = \ShopMagicTwilioVendor\Twilio\Values::of(['Authorization' => $options['authorization']]);
        $payload = $this->version->update('POST', $this->uri, [], $data, $headers);
        return new \ShopMagicTwilioVendor\Twilio\Rest\FlexApi\V1\AssessmentsInstance($this->version, $payload, $this->solution['assessmentSid']);
    }
    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString() : string
    {
        $context = [];
        foreach ($this->solution as $key => $value) {
            $context[] = "{$key}={$value}";
        }
        return '[Twilio.FlexApi.V1.AssessmentsContext ' . \implode(' ', $context) . ']';
    }
}
