<?php

/**
 * This code was generated by
 * ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
 *  |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
 *  |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \
 *
 * Twilio - Flex
 * This is the public Twilio REST API.
 *
 * NOTE: This class is auto generated by OpenAPI Generator.
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
namespace ShopMagicTwilioVendor\Twilio\Rest\FlexApi\V1;

use ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException;
use ShopMagicTwilioVendor\Twilio\InstanceResource;
use ShopMagicTwilioVendor\Twilio\Options;
use ShopMagicTwilioVendor\Twilio\Values;
use ShopMagicTwilioVendor\Twilio\Version;
/**
 * @property string|null $accountSid
 * @property string|null $assessmentSid
 * @property string|null $offset
 * @property bool|null $report
 * @property string|null $weight
 * @property string|null $agentId
 * @property string|null $segmentId
 * @property string|null $userName
 * @property string|null $userEmail
 * @property string|null $answerText
 * @property string|null $answerId
 * @property array|null $assessment
 * @property string|null $timestamp
 * @property string|null $url
 */
class AssessmentsInstance extends \ShopMagicTwilioVendor\Twilio\InstanceResource
{
    /**
     * Initialize the AssessmentsInstance
     *
     * @param Version $version Version that contains the resource
     * @param mixed[] $payload The response payload
     * @param string $assessmentSid The SID of the assessment to be modified
     */
    public function __construct(\ShopMagicTwilioVendor\Twilio\Version $version, array $payload, string $assessmentSid = null)
    {
        parent::__construct($version);
        // Marshaled Properties
        $this->properties = ['accountSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'account_sid'), 'assessmentSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'assessment_sid'), 'offset' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'offset'), 'report' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'report'), 'weight' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'weight'), 'agentId' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'agent_id'), 'segmentId' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'segment_id'), 'userName' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'user_name'), 'userEmail' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'user_email'), 'answerText' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'answer_text'), 'answerId' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'answer_id'), 'assessment' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'assessment'), 'timestamp' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'timestamp'), 'url' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'url')];
        $this->solution = ['assessmentSid' => $assessmentSid ?: $this->properties['assessmentSid']];
    }
    /**
     * Generate an instance context for the instance, the context is capable of
     * performing various actions.  All instance actions are proxied to the context
     *
     * @return AssessmentsContext Context for this AssessmentsInstance
     */
    protected function proxy() : \ShopMagicTwilioVendor\Twilio\Rest\FlexApi\V1\AssessmentsContext
    {
        if (!$this->context) {
            $this->context = new \ShopMagicTwilioVendor\Twilio\Rest\FlexApi\V1\AssessmentsContext($this->version, $this->solution['assessmentSid']);
        }
        return $this->context;
    }
    /**
     * Update the AssessmentsInstance
     *
     * @param string $offset The offset of the conversation
     * @param string $answerText The answer text selected by user
     * @param string $answerId The id of the answer selected by user
     * @param array|Options $options Optional Arguments
     * @return AssessmentsInstance Updated AssessmentsInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function update(string $offset, string $answerText, string $answerId, array $options = []) : \ShopMagicTwilioVendor\Twilio\Rest\FlexApi\V1\AssessmentsInstance
    {
        return $this->proxy()->update($offset, $answerText, $answerId, $options);
    }
    /**
     * Magic getter to access properties
     *
     * @param string $name Property to access
     * @return mixed The requested property
     * @throws TwilioException For unknown properties
     */
    public function __get(string $name)
    {
        if (\array_key_exists($name, $this->properties)) {
            return $this->properties[$name];
        }
        if (\property_exists($this, '_' . $name)) {
            $method = 'get' . \ucfirst($name);
            return $this->{$method}();
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Unknown property: ' . $name);
    }
    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString() : string
    {
        $context = [];
        foreach ($this->solution as $key => $value) {
            $context[] = "{$key}={$value}";
        }
        return '[Twilio.FlexApi.V1.AssessmentsInstance ' . \implode(' ', $context) . ']';
    }
}
