<?php

/**
 * This code was generated by
 * ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
 *  |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
 *  |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \
 *
 * Twilio - Flex
 * This is the public Twilio REST API.
 *
 * NOTE: This class is auto generated by OpenAPI Generator.
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
namespace ShopMagicTwilioVendor\Twilio\Rest\FlexApi\V1;

use ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException;
use ShopMagicTwilioVendor\Twilio\InstanceResource;
use ShopMagicTwilioVendor\Twilio\Options;
use ShopMagicTwilioVendor\Twilio\Values;
use ShopMagicTwilioVendor\Twilio\Version;
/**
 * @property string|null $accountSid
 * @property string|null $questionnaireSid
 * @property string|null $name
 * @property string|null $description
 * @property bool|null $active
 * @property array[]|null $questions
 * @property string|null $url
 */
class InsightsQuestionnairesInstance extends \ShopMagicTwilioVendor\Twilio\InstanceResource
{
    /**
     * Initialize the InsightsQuestionnairesInstance
     *
     * @param Version $version Version that contains the resource
     * @param mixed[] $payload The response payload
     * @param string $questionnaireSid The SID of the questionnaire
     */
    public function __construct(\ShopMagicTwilioVendor\Twilio\Version $version, array $payload, string $questionnaireSid = null)
    {
        parent::__construct($version);
        // Marshaled Properties
        $this->properties = ['accountSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'account_sid'), 'questionnaireSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'questionnaire_sid'), 'name' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'name'), 'description' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'description'), 'active' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'active'), 'questions' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'questions'), 'url' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'url')];
        $this->solution = ['questionnaireSid' => $questionnaireSid ?: $this->properties['questionnaireSid']];
    }
    /**
     * Generate an instance context for the instance, the context is capable of
     * performing various actions.  All instance actions are proxied to the context
     *
     * @return InsightsQuestionnairesContext Context for this InsightsQuestionnairesInstance
     */
    protected function proxy() : \ShopMagicTwilioVendor\Twilio\Rest\FlexApi\V1\InsightsQuestionnairesContext
    {
        if (!$this->context) {
            $this->context = new \ShopMagicTwilioVendor\Twilio\Rest\FlexApi\V1\InsightsQuestionnairesContext($this->version, $this->solution['questionnaireSid']);
        }
        return $this->context;
    }
    /**
     * Delete the InsightsQuestionnairesInstance
     *
     * @param array|Options $options Optional Arguments
     * @return bool True if delete succeeds, false otherwise
     * @throws TwilioException When an HTTP error occurs.
     */
    public function delete(array $options = []) : bool
    {
        return $this->proxy()->delete($options);
    }
    /**
     * Fetch the InsightsQuestionnairesInstance
     *
     * @param array|Options $options Optional Arguments
     * @return InsightsQuestionnairesInstance Fetched InsightsQuestionnairesInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function fetch(array $options = []) : \ShopMagicTwilioVendor\Twilio\Rest\FlexApi\V1\InsightsQuestionnairesInstance
    {
        return $this->proxy()->fetch($options);
    }
    /**
     * Update the InsightsQuestionnairesInstance
     *
     * @param bool $active The flag to enable or disable questionnaire
     * @param array|Options $options Optional Arguments
     * @return InsightsQuestionnairesInstance Updated InsightsQuestionnairesInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function update(bool $active, array $options = []) : \ShopMagicTwilioVendor\Twilio\Rest\FlexApi\V1\InsightsQuestionnairesInstance
    {
        return $this->proxy()->update($active, $options);
    }
    /**
     * Magic getter to access properties
     *
     * @param string $name Property to access
     * @return mixed The requested property
     * @throws TwilioException For unknown properties
     */
    public function __get(string $name)
    {
        if (\array_key_exists($name, $this->properties)) {
            return $this->properties[$name];
        }
        if (\property_exists($this, '_' . $name)) {
            $method = 'get' . \ucfirst($name);
            return $this->{$method}();
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Unknown property: ' . $name);
    }
    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString() : string
    {
        $context = [];
        foreach ($this->solution as $key => $value) {
            $context[] = "{$key}={$value}";
        }
        return '[Twilio.FlexApi.V1.InsightsQuestionnairesInstance ' . \implode(' ', $context) . ']';
    }
}
