<?php

/**
 * This code was generated by
 * ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
 *  |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
 *  |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \
 *
 * Twilio - Insights
 * This is the public Twilio REST API.
 *
 * NOTE: This class is auto generated by OpenAPI Generator.
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
namespace ShopMagicTwilioVendor\Twilio\Rest\Insights\V1\Call;

use ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException;
use ShopMagicTwilioVendor\Twilio\InstanceResource;
use ShopMagicTwilioVendor\Twilio\Options;
use ShopMagicTwilioVendor\Twilio\Values;
use ShopMagicTwilioVendor\Twilio\Version;
use ShopMagicTwilioVendor\Twilio\Deserialize;
/**
 * @property string|null $accountSid
 * @property string|null $callSid
 * @property string $callType
 * @property string $callState
 * @property string $answeredBy
 * @property string $processingState
 * @property \DateTime|null $createdTime
 * @property \DateTime|null $startTime
 * @property \DateTime|null $endTime
 * @property int|null $duration
 * @property int|null $connectDuration
 * @property array|null $from
 * @property array|null $to
 * @property array|null $carrierEdge
 * @property array|null $clientEdge
 * @property array|null $sdkEdge
 * @property array|null $sipEdge
 * @property string[]|null $tags
 * @property string|null $url
 * @property array|null $attributes
 * @property array|null $properties
 * @property array|null $trust
 * @property array|null $annotation
 */
class CallSummaryInstance extends \ShopMagicTwilioVendor\Twilio\InstanceResource
{
    /**
     * Initialize the CallSummaryInstance
     *
     * @param Version $version Version that contains the resource
     * @param mixed[] $payload The response payload
     * @param string $callSid The unique SID identifier of the Call.
     */
    public function __construct(\ShopMagicTwilioVendor\Twilio\Version $version, array $payload, string $callSid)
    {
        parent::__construct($version);
        // Marshaled Properties
        $this->properties = ['accountSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'account_sid'), 'callSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'call_sid'), 'callType' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'call_type'), 'callState' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'call_state'), 'answeredBy' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'answered_by'), 'processingState' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'processing_state'), 'createdTime' => \ShopMagicTwilioVendor\Twilio\Deserialize::dateTime(\ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'created_time')), 'startTime' => \ShopMagicTwilioVendor\Twilio\Deserialize::dateTime(\ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'start_time')), 'endTime' => \ShopMagicTwilioVendor\Twilio\Deserialize::dateTime(\ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'end_time')), 'duration' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'duration'), 'connectDuration' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'connect_duration'), 'from' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'from'), 'to' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'to'), 'carrierEdge' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'carrier_edge'), 'clientEdge' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'client_edge'), 'sdkEdge' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'sdk_edge'), 'sipEdge' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'sip_edge'), 'tags' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'tags'), 'url' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'url'), 'attributes' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'attributes'), 'properties' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'properties'), 'trust' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'trust'), 'annotation' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'annotation')];
        $this->solution = ['callSid' => $callSid];
    }
    /**
     * Generate an instance context for the instance, the context is capable of
     * performing various actions.  All instance actions are proxied to the context
     *
     * @return CallSummaryContext Context for this CallSummaryInstance
     */
    protected function proxy() : \ShopMagicTwilioVendor\Twilio\Rest\Insights\V1\Call\CallSummaryContext
    {
        if (!$this->context) {
            $this->context = new \ShopMagicTwilioVendor\Twilio\Rest\Insights\V1\Call\CallSummaryContext($this->version, $this->solution['callSid']);
        }
        return $this->context;
    }
    /**
     * Fetch the CallSummaryInstance
     *
     * @param array|Options $options Optional Arguments
     * @return CallSummaryInstance Fetched CallSummaryInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function fetch(array $options = []) : \ShopMagicTwilioVendor\Twilio\Rest\Insights\V1\Call\CallSummaryInstance
    {
        return $this->proxy()->fetch($options);
    }
    /**
     * Magic getter to access properties
     *
     * @param string $name Property to access
     * @return mixed The requested property
     * @throws TwilioException For unknown properties
     */
    public function __get(string $name)
    {
        if (\array_key_exists($name, $this->properties)) {
            return $this->properties[$name];
        }
        if (\property_exists($this, '_' . $name)) {
            $method = 'get' . \ucfirst($name);
            return $this->{$method}();
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Unknown property: ' . $name);
    }
    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString() : string
    {
        $context = [];
        foreach ($this->solution as $key => $value) {
            $context[] = "{$key}={$value}";
        }
        return '[Twilio.Insights.V1.CallSummaryInstance ' . \implode(' ', $context) . ']';
    }
}
