<?php

/**
 * This code was generated by
 * ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
 *  |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
 *  |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \
 *
 * Twilio - Insights
 * This is the public Twilio REST API.
 *
 * NOTE: This class is auto generated by OpenAPI Generator.
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
namespace ShopMagicTwilioVendor\Twilio\Rest\Insights\V1;

use ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException;
use ShopMagicTwilioVendor\Twilio\ListResource;
use ShopMagicTwilioVendor\Twilio\Version;
use ShopMagicTwilioVendor\Twilio\InstanceContext;
use ShopMagicTwilioVendor\Twilio\Rest\Insights\V1\Call\MetricList;
use ShopMagicTwilioVendor\Twilio\Rest\Insights\V1\Call\EventList;
use ShopMagicTwilioVendor\Twilio\Rest\Insights\V1\Call\CallSummaryList;
use ShopMagicTwilioVendor\Twilio\Rest\Insights\V1\Call\AnnotationList;
/**
 * @property MetricList $metrics
 * @property EventList $events
 * @property CallSummaryList $summary
 * @property AnnotationList $annotation
 * @method \Twilio\Rest\Insights\V1\Call\CallSummaryContext summary()
 * @method \Twilio\Rest\Insights\V1\Call\AnnotationContext annotation()
 */
class CallContext extends \ShopMagicTwilioVendor\Twilio\InstanceContext
{
    protected $_metrics;
    protected $_events;
    protected $_summary;
    protected $_annotation;
    /**
     * Initialize the CallContext
     *
     * @param Version $version Version that contains the resource
     * @param string $sid 
     */
    public function __construct(\ShopMagicTwilioVendor\Twilio\Version $version, $sid)
    {
        parent::__construct($version);
        // Path Solution
        $this->solution = ['sid' => $sid];
        $this->uri = '/Voice/' . \rawurlencode($sid) . '';
    }
    /**
     * Fetch the CallInstance
     *
     * @return CallInstance Fetched CallInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function fetch() : \ShopMagicTwilioVendor\Twilio\Rest\Insights\V1\CallInstance
    {
        $payload = $this->version->fetch('GET', $this->uri);
        return new \ShopMagicTwilioVendor\Twilio\Rest\Insights\V1\CallInstance($this->version, $payload, $this->solution['sid']);
    }
    /**
     * Access the metrics
     */
    protected function getMetrics() : \ShopMagicTwilioVendor\Twilio\Rest\Insights\V1\Call\MetricList
    {
        if (!$this->_metrics) {
            $this->_metrics = new \ShopMagicTwilioVendor\Twilio\Rest\Insights\V1\Call\MetricList($this->version, $this->solution['sid']);
        }
        return $this->_metrics;
    }
    /**
     * Access the events
     */
    protected function getEvents() : \ShopMagicTwilioVendor\Twilio\Rest\Insights\V1\Call\EventList
    {
        if (!$this->_events) {
            $this->_events = new \ShopMagicTwilioVendor\Twilio\Rest\Insights\V1\Call\EventList($this->version, $this->solution['sid']);
        }
        return $this->_events;
    }
    /**
     * Access the summary
     */
    protected function getSummary() : \ShopMagicTwilioVendor\Twilio\Rest\Insights\V1\Call\CallSummaryList
    {
        if (!$this->_summary) {
            $this->_summary = new \ShopMagicTwilioVendor\Twilio\Rest\Insights\V1\Call\CallSummaryList($this->version, $this->solution['sid']);
        }
        return $this->_summary;
    }
    /**
     * Access the annotation
     */
    protected function getAnnotation() : \ShopMagicTwilioVendor\Twilio\Rest\Insights\V1\Call\AnnotationList
    {
        if (!$this->_annotation) {
            $this->_annotation = new \ShopMagicTwilioVendor\Twilio\Rest\Insights\V1\Call\AnnotationList($this->version, $this->solution['sid']);
        }
        return $this->_annotation;
    }
    /**
     * Magic getter to lazy load subresources
     *
     * @param string $name Subresource to return
     * @return ListResource The requested subresource
     * @throws TwilioException For unknown subresources
     */
    public function __get(string $name) : \ShopMagicTwilioVendor\Twilio\ListResource
    {
        if (\property_exists($this, '_' . $name)) {
            $method = 'get' . \ucfirst($name);
            return $this->{$method}();
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Unknown subresource ' . $name);
    }
    /**
     * Magic caller to get resource contexts
     *
     * @param string $name Resource to return
     * @param array $arguments Context parameters
     * @return InstanceContext The requested resource context
     * @throws TwilioException For unknown resource
     */
    public function __call(string $name, array $arguments) : \ShopMagicTwilioVendor\Twilio\InstanceContext
    {
        $property = $this->{$name};
        if (\method_exists($property, 'getContext')) {
            return \call_user_func_array(array($property, 'getContext'), $arguments);
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Resource does not have a context');
    }
    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString() : string
    {
        $context = [];
        foreach ($this->solution as $key => $value) {
            $context[] = "{$key}={$value}";
        }
        return '[Twilio.Insights.V1.CallContext ' . \implode(' ', $context) . ']';
    }
}
