<?php

/**
 * This code was generated by
 * ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
 *  |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
 *  |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \
 *
 * Twilio - Insights
 * This is the public Twilio REST API.
 *
 * NOTE: This class is auto generated by OpenAPI Generator.
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
namespace ShopMagicTwilioVendor\Twilio\Rest\Insights\V1;

use ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException;
use ShopMagicTwilioVendor\Twilio\InstanceResource;
use ShopMagicTwilioVendor\Twilio\Values;
use ShopMagicTwilioVendor\Twilio\Version;
use ShopMagicTwilioVendor\Twilio\Rest\Insights\V1\Call\MetricList;
use ShopMagicTwilioVendor\Twilio\Rest\Insights\V1\Call\EventList;
use ShopMagicTwilioVendor\Twilio\Rest\Insights\V1\Call\CallSummaryList;
use ShopMagicTwilioVendor\Twilio\Rest\Insights\V1\Call\AnnotationList;
/**
 * @property string|null $sid
 * @property string|null $url
 * @property array|null $links
 */
class CallInstance extends \ShopMagicTwilioVendor\Twilio\InstanceResource
{
    protected $_metrics;
    protected $_events;
    protected $_summary;
    protected $_annotation;
    /**
     * Initialize the CallInstance
     *
     * @param Version $version Version that contains the resource
     * @param mixed[] $payload The response payload
     * @param string $sid 
     */
    public function __construct(\ShopMagicTwilioVendor\Twilio\Version $version, array $payload, string $sid = null)
    {
        parent::__construct($version);
        // Marshaled Properties
        $this->properties = ['sid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'sid'), 'url' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'url'), 'links' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'links')];
        $this->solution = ['sid' => $sid ?: $this->properties['sid']];
    }
    /**
     * Generate an instance context for the instance, the context is capable of
     * performing various actions.  All instance actions are proxied to the context
     *
     * @return CallContext Context for this CallInstance
     */
    protected function proxy() : \ShopMagicTwilioVendor\Twilio\Rest\Insights\V1\CallContext
    {
        if (!$this->context) {
            $this->context = new \ShopMagicTwilioVendor\Twilio\Rest\Insights\V1\CallContext($this->version, $this->solution['sid']);
        }
        return $this->context;
    }
    /**
     * Fetch the CallInstance
     *
     * @return CallInstance Fetched CallInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function fetch() : \ShopMagicTwilioVendor\Twilio\Rest\Insights\V1\CallInstance
    {
        return $this->proxy()->fetch();
    }
    /**
     * Access the metrics
     */
    protected function getMetrics() : \ShopMagicTwilioVendor\Twilio\Rest\Insights\V1\Call\MetricList
    {
        return $this->proxy()->metrics;
    }
    /**
     * Access the events
     */
    protected function getEvents() : \ShopMagicTwilioVendor\Twilio\Rest\Insights\V1\Call\EventList
    {
        return $this->proxy()->events;
    }
    /**
     * Access the summary
     */
    protected function getSummary() : \ShopMagicTwilioVendor\Twilio\Rest\Insights\V1\Call\CallSummaryList
    {
        return $this->proxy()->summary;
    }
    /**
     * Access the annotation
     */
    protected function getAnnotation() : \ShopMagicTwilioVendor\Twilio\Rest\Insights\V1\Call\AnnotationList
    {
        return $this->proxy()->annotation;
    }
    /**
     * Magic getter to access properties
     *
     * @param string $name Property to access
     * @return mixed The requested property
     * @throws TwilioException For unknown properties
     */
    public function __get(string $name)
    {
        if (\array_key_exists($name, $this->properties)) {
            return $this->properties[$name];
        }
        if (\property_exists($this, '_' . $name)) {
            $method = 'get' . \ucfirst($name);
            return $this->{$method}();
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Unknown property: ' . $name);
    }
    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString() : string
    {
        $context = [];
        foreach ($this->solution as $key => $value) {
            $context[] = "{$key}={$value}";
        }
        return '[Twilio.Insights.V1.CallInstance ' . \implode(' ', $context) . ']';
    }
}
