<?php

/**
 * This code was generated by
 * ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
 *  |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
 *  |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \
 *
 * Twilio - Insights
 * This is the public Twilio REST API.
 *
 * NOTE: This class is auto generated by OpenAPI Generator.
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
namespace ShopMagicTwilioVendor\Twilio\Rest\Insights\V1;

use ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException;
use ShopMagicTwilioVendor\Twilio\InstanceResource;
use ShopMagicTwilioVendor\Twilio\Values;
use ShopMagicTwilioVendor\Twilio\Version;
use ShopMagicTwilioVendor\Twilio\Deserialize;
use ShopMagicTwilioVendor\Twilio\Rest\Insights\V1\Room\ParticipantList;
/**
 * @property string|null $accountSid
 * @property string|null $roomSid
 * @property string|null $roomName
 * @property \DateTime|null $createTime
 * @property \DateTime|null $endTime
 * @property string $roomType
 * @property string $roomStatus
 * @property string|null $statusCallback
 * @property string|null $statusCallbackMethod
 * @property string $createdMethod
 * @property string $endReason
 * @property int|null $maxParticipants
 * @property int|null $uniqueParticipants
 * @property int|null $uniqueParticipantIdentities
 * @property int|null $concurrentParticipants
 * @property int|null $maxConcurrentParticipants
 * @property string[]|null $codecs
 * @property string $mediaRegion
 * @property int|null $durationSec
 * @property int|null $totalParticipantDurationSec
 * @property int|null $totalRecordingDurationSec
 * @property string $processingState
 * @property bool|null $recordingEnabled
 * @property string $edgeLocation
 * @property string|null $url
 * @property array|null $links
 */
class RoomInstance extends \ShopMagicTwilioVendor\Twilio\InstanceResource
{
    protected $_participants;
    /**
     * Initialize the RoomInstance
     *
     * @param Version $version Version that contains the resource
     * @param mixed[] $payload The response payload
     * @param string $roomSid The SID of the Room resource.
     */
    public function __construct(\ShopMagicTwilioVendor\Twilio\Version $version, array $payload, string $roomSid = null)
    {
        parent::__construct($version);
        // Marshaled Properties
        $this->properties = ['accountSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'account_sid'), 'roomSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'room_sid'), 'roomName' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'room_name'), 'createTime' => \ShopMagicTwilioVendor\Twilio\Deserialize::dateTime(\ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'create_time')), 'endTime' => \ShopMagicTwilioVendor\Twilio\Deserialize::dateTime(\ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'end_time')), 'roomType' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'room_type'), 'roomStatus' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'room_status'), 'statusCallback' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'status_callback'), 'statusCallbackMethod' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'status_callback_method'), 'createdMethod' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'created_method'), 'endReason' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'end_reason'), 'maxParticipants' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'max_participants'), 'uniqueParticipants' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'unique_participants'), 'uniqueParticipantIdentities' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'unique_participant_identities'), 'concurrentParticipants' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'concurrent_participants'), 'maxConcurrentParticipants' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'max_concurrent_participants'), 'codecs' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'codecs'), 'mediaRegion' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'media_region'), 'durationSec' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'duration_sec'), 'totalParticipantDurationSec' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'total_participant_duration_sec'), 'totalRecordingDurationSec' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'total_recording_duration_sec'), 'processingState' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'processing_state'), 'recordingEnabled' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'recording_enabled'), 'edgeLocation' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'edge_location'), 'url' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'url'), 'links' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'links')];
        $this->solution = ['roomSid' => $roomSid ?: $this->properties['roomSid']];
    }
    /**
     * Generate an instance context for the instance, the context is capable of
     * performing various actions.  All instance actions are proxied to the context
     *
     * @return RoomContext Context for this RoomInstance
     */
    protected function proxy() : \ShopMagicTwilioVendor\Twilio\Rest\Insights\V1\RoomContext
    {
        if (!$this->context) {
            $this->context = new \ShopMagicTwilioVendor\Twilio\Rest\Insights\V1\RoomContext($this->version, $this->solution['roomSid']);
        }
        return $this->context;
    }
    /**
     * Fetch the RoomInstance
     *
     * @return RoomInstance Fetched RoomInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function fetch() : \ShopMagicTwilioVendor\Twilio\Rest\Insights\V1\RoomInstance
    {
        return $this->proxy()->fetch();
    }
    /**
     * Access the participants
     */
    protected function getParticipants() : \ShopMagicTwilioVendor\Twilio\Rest\Insights\V1\Room\ParticipantList
    {
        return $this->proxy()->participants;
    }
    /**
     * Magic getter to access properties
     *
     * @param string $name Property to access
     * @return mixed The requested property
     * @throws TwilioException For unknown properties
     */
    public function __get(string $name)
    {
        if (\array_key_exists($name, $this->properties)) {
            return $this->properties[$name];
        }
        if (\property_exists($this, '_' . $name)) {
            $method = 'get' . \ucfirst($name);
            return $this->{$method}();
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Unknown property: ' . $name);
    }
    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString() : string
    {
        $context = [];
        foreach ($this->solution as $key => $value) {
            $context[] = "{$key}={$value}";
        }
        return '[Twilio.Insights.V1.RoomInstance ' . \implode(' ', $context) . ']';
    }
}
