<?php

/**
 * This code was generated by
 * ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
 *  |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
 *  |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \
 *
 * Twilio - Intelligence
 * This is the public Twilio REST API.
 *
 * NOTE: This class is auto generated by OpenAPI Generator.
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
namespace ShopMagicTwilioVendor\Twilio\Rest\Intelligence\V2\Transcript;

use ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException;
use ShopMagicTwilioVendor\Twilio\InstanceResource;
use ShopMagicTwilioVendor\Twilio\Options;
use ShopMagicTwilioVendor\Twilio\Values;
use ShopMagicTwilioVendor\Twilio\Version;
/**
 * @property string $operatorType
 * @property string|null $name
 * @property string|null $operatorSid
 * @property bool|null $extractMatch
 * @property string|null $matchProbability
 * @property string|null $normalizedResult
 * @property array[]|null $utteranceResults
 * @property bool|null $utteranceMatch
 * @property string|null $predictedLabel
 * @property string|null $predictedProbability
 * @property array|null $labelProbabilities
 * @property array|null $extractResults
 * @property array|null $textGenerationResults
 * @property string|null $transcriptSid
 * @property string|null $url
 */
class OperatorResultInstance extends \ShopMagicTwilioVendor\Twilio\InstanceResource
{
    /**
     * Initialize the OperatorResultInstance
     *
     * @param Version $version Version that contains the resource
     * @param mixed[] $payload The response payload
     * @param string $transcriptSid A 34 character string that uniquely identifies this Transcript.
     * @param string $operatorSid A 34 character string that identifies this Language Understanding operator sid.
     */
    public function __construct(\ShopMagicTwilioVendor\Twilio\Version $version, array $payload, string $transcriptSid, string $operatorSid = null)
    {
        parent::__construct($version);
        // Marshaled Properties
        $this->properties = ['operatorType' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'operator_type'), 'name' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'name'), 'operatorSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'operator_sid'), 'extractMatch' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'extract_match'), 'matchProbability' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'match_probability'), 'normalizedResult' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'normalized_result'), 'utteranceResults' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'utterance_results'), 'utteranceMatch' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'utterance_match'), 'predictedLabel' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'predicted_label'), 'predictedProbability' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'predicted_probability'), 'labelProbabilities' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'label_probabilities'), 'extractResults' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'extract_results'), 'textGenerationResults' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'text_generation_results'), 'transcriptSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'transcript_sid'), 'url' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'url')];
        $this->solution = ['transcriptSid' => $transcriptSid, 'operatorSid' => $operatorSid ?: $this->properties['operatorSid']];
    }
    /**
     * Generate an instance context for the instance, the context is capable of
     * performing various actions.  All instance actions are proxied to the context
     *
     * @return OperatorResultContext Context for this OperatorResultInstance
     */
    protected function proxy() : \ShopMagicTwilioVendor\Twilio\Rest\Intelligence\V2\Transcript\OperatorResultContext
    {
        if (!$this->context) {
            $this->context = new \ShopMagicTwilioVendor\Twilio\Rest\Intelligence\V2\Transcript\OperatorResultContext($this->version, $this->solution['transcriptSid'], $this->solution['operatorSid']);
        }
        return $this->context;
    }
    /**
     * Fetch the OperatorResultInstance
     *
     * @param array|Options $options Optional Arguments
     * @return OperatorResultInstance Fetched OperatorResultInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function fetch(array $options = []) : \ShopMagicTwilioVendor\Twilio\Rest\Intelligence\V2\Transcript\OperatorResultInstance
    {
        return $this->proxy()->fetch($options);
    }
    /**
     * Magic getter to access properties
     *
     * @param string $name Property to access
     * @return mixed The requested property
     * @throws TwilioException For unknown properties
     */
    public function __get(string $name)
    {
        if (\array_key_exists($name, $this->properties)) {
            return $this->properties[$name];
        }
        if (\property_exists($this, '_' . $name)) {
            $method = 'get' . \ucfirst($name);
            return $this->{$method}();
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Unknown property: ' . $name);
    }
    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString() : string
    {
        $context = [];
        foreach ($this->solution as $key => $value) {
            $context[] = "{$key}={$value}";
        }
        return '[Twilio.Intelligence.V2.OperatorResultInstance ' . \implode(' ', $context) . ']';
    }
}
