<?php

/**
 * This code was generated by
 * ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
 *  |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
 *  |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \
 *
 * Twilio - Messaging
 * This is the public Twilio REST API.
 *
 * NOTE: This class is auto generated by OpenAPI Generator.
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
namespace ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\BrandRegistration;

use ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException;
use ShopMagicTwilioVendor\Twilio\InstanceResource;
use ShopMagicTwilioVendor\Twilio\Values;
use ShopMagicTwilioVendor\Twilio\Version;
use ShopMagicTwilioVendor\Twilio\Deserialize;
/**
 * @property string|null $accountSid
 * @property string|null $brandSid
 * @property string|null $brandVettingSid
 * @property \DateTime|null $dateUpdated
 * @property \DateTime|null $dateCreated
 * @property string|null $vettingId
 * @property string|null $vettingClass
 * @property string|null $vettingStatus
 * @property string $vettingProvider
 * @property string|null $url
 */
class BrandVettingInstance extends \ShopMagicTwilioVendor\Twilio\InstanceResource
{
    /**
     * Initialize the BrandVettingInstance
     *
     * @param Version $version Version that contains the resource
     * @param mixed[] $payload The response payload
     * @param string $brandSid The SID of the Brand Registration resource of the vettings to create .
     * @param string $brandVettingSid The Twilio SID of the third-party vetting record.
     */
    public function __construct(\ShopMagicTwilioVendor\Twilio\Version $version, array $payload, string $brandSid, string $brandVettingSid = null)
    {
        parent::__construct($version);
        // Marshaled Properties
        $this->properties = ['accountSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'account_sid'), 'brandSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'brand_sid'), 'brandVettingSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'brand_vetting_sid'), 'dateUpdated' => \ShopMagicTwilioVendor\Twilio\Deserialize::dateTime(\ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'date_updated')), 'dateCreated' => \ShopMagicTwilioVendor\Twilio\Deserialize::dateTime(\ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'date_created')), 'vettingId' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'vetting_id'), 'vettingClass' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'vetting_class'), 'vettingStatus' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'vetting_status'), 'vettingProvider' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'vetting_provider'), 'url' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'url')];
        $this->solution = ['brandSid' => $brandSid, 'brandVettingSid' => $brandVettingSid ?: $this->properties['brandVettingSid']];
    }
    /**
     * Generate an instance context for the instance, the context is capable of
     * performing various actions.  All instance actions are proxied to the context
     *
     * @return BrandVettingContext Context for this BrandVettingInstance
     */
    protected function proxy() : \ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\BrandRegistration\BrandVettingContext
    {
        if (!$this->context) {
            $this->context = new \ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\BrandRegistration\BrandVettingContext($this->version, $this->solution['brandSid'], $this->solution['brandVettingSid']);
        }
        return $this->context;
    }
    /**
     * Fetch the BrandVettingInstance
     *
     * @return BrandVettingInstance Fetched BrandVettingInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function fetch() : \ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\BrandRegistration\BrandVettingInstance
    {
        return $this->proxy()->fetch();
    }
    /**
     * Magic getter to access properties
     *
     * @param string $name Property to access
     * @return mixed The requested property
     * @throws TwilioException For unknown properties
     */
    public function __get(string $name)
    {
        if (\array_key_exists($name, $this->properties)) {
            return $this->properties[$name];
        }
        if (\property_exists($this, '_' . $name)) {
            $method = 'get' . \ucfirst($name);
            return $this->{$method}();
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Unknown property: ' . $name);
    }
    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString() : string
    {
        $context = [];
        foreach ($this->solution as $key => $value) {
            $context[] = "{$key}={$value}";
        }
        return '[Twilio.Messaging.V1.BrandVettingInstance ' . \implode(' ', $context) . ']';
    }
}
