<?php

/**
 * This code was generated by
 * ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
 *  |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
 *  |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \
 *
 * Twilio - Messaging
 * This is the public Twilio REST API.
 *
 * NOTE: This class is auto generated by OpenAPI Generator.
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
namespace ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1;

use ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException;
use ShopMagicTwilioVendor\Twilio\ListResource;
use ShopMagicTwilioVendor\Twilio\Options;
use ShopMagicTwilioVendor\Twilio\Values;
use ShopMagicTwilioVendor\Twilio\Version;
use ShopMagicTwilioVendor\Twilio\InstanceContext;
use ShopMagicTwilioVendor\Twilio\Serialize;
use ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\Service\AlphaSenderList;
use ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\Service\PhoneNumberList;
use ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\Service\UsAppToPersonUsecaseList;
use ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\Service\ChannelSenderList;
use ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\Service\ShortCodeList;
use ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\Service\UsAppToPersonList;
/**
 * @property AlphaSenderList $alphaSenders
 * @property PhoneNumberList $phoneNumbers
 * @property UsAppToPersonUsecaseList $usAppToPersonUsecases
 * @property ChannelSenderList $channelSenders
 * @property ShortCodeList $shortCodes
 * @property UsAppToPersonList $usAppToPerson
 * @method \Twilio\Rest\Messaging\V1\Service\ShortCodeContext shortCodes(string $sid)
 * @method \Twilio\Rest\Messaging\V1\Service\UsAppToPersonContext usAppToPerson(string $sid)
 * @method \Twilio\Rest\Messaging\V1\Service\PhoneNumberContext phoneNumbers(string $sid)
 * @method \Twilio\Rest\Messaging\V1\Service\AlphaSenderContext alphaSenders(string $sid)
 * @method \Twilio\Rest\Messaging\V1\Service\ChannelSenderContext channelSenders(string $sid)
 */
class ServiceContext extends \ShopMagicTwilioVendor\Twilio\InstanceContext
{
    protected $_alphaSenders;
    protected $_phoneNumbers;
    protected $_usAppToPersonUsecases;
    protected $_channelSenders;
    protected $_shortCodes;
    protected $_usAppToPerson;
    /**
     * Initialize the ServiceContext
     *
     * @param Version $version Version that contains the resource
     * @param string $sid The SID of the Service resource to delete.
     */
    public function __construct(\ShopMagicTwilioVendor\Twilio\Version $version, $sid)
    {
        parent::__construct($version);
        // Path Solution
        $this->solution = ['sid' => $sid];
        $this->uri = '/Services/' . \rawurlencode($sid) . '';
    }
    /**
     * Delete the ServiceInstance
     *
     * @return bool True if delete succeeds, false otherwise
     * @throws TwilioException When an HTTP error occurs.
     */
    public function delete() : bool
    {
        return $this->version->delete('DELETE', $this->uri);
    }
    /**
     * Fetch the ServiceInstance
     *
     * @return ServiceInstance Fetched ServiceInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function fetch() : \ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\ServiceInstance
    {
        $payload = $this->version->fetch('GET', $this->uri);
        return new \ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\ServiceInstance($this->version, $payload, $this->solution['sid']);
    }
    /**
     * Update the ServiceInstance
     *
     * @param array|Options $options Optional Arguments
     * @return ServiceInstance Updated ServiceInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function update(array $options = []) : \ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\ServiceInstance
    {
        $options = new \ShopMagicTwilioVendor\Twilio\Values($options);
        $data = \ShopMagicTwilioVendor\Twilio\Values::of(['FriendlyName' => $options['friendlyName'], 'InboundRequestUrl' => $options['inboundRequestUrl'], 'InboundMethod' => $options['inboundMethod'], 'FallbackUrl' => $options['fallbackUrl'], 'FallbackMethod' => $options['fallbackMethod'], 'StatusCallback' => $options['statusCallback'], 'StickySender' => \ShopMagicTwilioVendor\Twilio\Serialize::booleanToString($options['stickySender']), 'MmsConverter' => \ShopMagicTwilioVendor\Twilio\Serialize::booleanToString($options['mmsConverter']), 'SmartEncoding' => \ShopMagicTwilioVendor\Twilio\Serialize::booleanToString($options['smartEncoding']), 'ScanMessageContent' => $options['scanMessageContent'], 'FallbackToLongCode' => \ShopMagicTwilioVendor\Twilio\Serialize::booleanToString($options['fallbackToLongCode']), 'AreaCodeGeomatch' => \ShopMagicTwilioVendor\Twilio\Serialize::booleanToString($options['areaCodeGeomatch']), 'ValidityPeriod' => $options['validityPeriod'], 'SynchronousValidation' => \ShopMagicTwilioVendor\Twilio\Serialize::booleanToString($options['synchronousValidation']), 'Usecase' => $options['usecase'], 'UseInboundWebhookOnNumber' => \ShopMagicTwilioVendor\Twilio\Serialize::booleanToString($options['useInboundWebhookOnNumber'])]);
        $payload = $this->version->update('POST', $this->uri, [], $data);
        return new \ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\ServiceInstance($this->version, $payload, $this->solution['sid']);
    }
    /**
     * Access the alphaSenders
     */
    protected function getAlphaSenders() : \ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\Service\AlphaSenderList
    {
        if (!$this->_alphaSenders) {
            $this->_alphaSenders = new \ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\Service\AlphaSenderList($this->version, $this->solution['sid']);
        }
        return $this->_alphaSenders;
    }
    /**
     * Access the phoneNumbers
     */
    protected function getPhoneNumbers() : \ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\Service\PhoneNumberList
    {
        if (!$this->_phoneNumbers) {
            $this->_phoneNumbers = new \ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\Service\PhoneNumberList($this->version, $this->solution['sid']);
        }
        return $this->_phoneNumbers;
    }
    /**
     * Access the usAppToPersonUsecases
     */
    protected function getUsAppToPersonUsecases() : \ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\Service\UsAppToPersonUsecaseList
    {
        if (!$this->_usAppToPersonUsecases) {
            $this->_usAppToPersonUsecases = new \ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\Service\UsAppToPersonUsecaseList($this->version, $this->solution['sid']);
        }
        return $this->_usAppToPersonUsecases;
    }
    /**
     * Access the channelSenders
     */
    protected function getChannelSenders() : \ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\Service\ChannelSenderList
    {
        if (!$this->_channelSenders) {
            $this->_channelSenders = new \ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\Service\ChannelSenderList($this->version, $this->solution['sid']);
        }
        return $this->_channelSenders;
    }
    /**
     * Access the shortCodes
     */
    protected function getShortCodes() : \ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\Service\ShortCodeList
    {
        if (!$this->_shortCodes) {
            $this->_shortCodes = new \ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\Service\ShortCodeList($this->version, $this->solution['sid']);
        }
        return $this->_shortCodes;
    }
    /**
     * Access the usAppToPerson
     */
    protected function getUsAppToPerson() : \ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\Service\UsAppToPersonList
    {
        if (!$this->_usAppToPerson) {
            $this->_usAppToPerson = new \ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\Service\UsAppToPersonList($this->version, $this->solution['sid']);
        }
        return $this->_usAppToPerson;
    }
    /**
     * Magic getter to lazy load subresources
     *
     * @param string $name Subresource to return
     * @return ListResource The requested subresource
     * @throws TwilioException For unknown subresources
     */
    public function __get(string $name) : \ShopMagicTwilioVendor\Twilio\ListResource
    {
        if (\property_exists($this, '_' . $name)) {
            $method = 'get' . \ucfirst($name);
            return $this->{$method}();
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Unknown subresource ' . $name);
    }
    /**
     * Magic caller to get resource contexts
     *
     * @param string $name Resource to return
     * @param array $arguments Context parameters
     * @return InstanceContext The requested resource context
     * @throws TwilioException For unknown resource
     */
    public function __call(string $name, array $arguments) : \ShopMagicTwilioVendor\Twilio\InstanceContext
    {
        $property = $this->{$name};
        if (\method_exists($property, 'getContext')) {
            return \call_user_func_array(array($property, 'getContext'), $arguments);
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Resource does not have a context');
    }
    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString() : string
    {
        $context = [];
        foreach ($this->solution as $key => $value) {
            $context[] = "{$key}={$value}";
        }
        return '[Twilio.Messaging.V1.ServiceContext ' . \implode(' ', $context) . ']';
    }
}
