<?php

/**
 * This code was generated by
 * ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
 *  |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
 *  |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \
 *
 * Twilio - Messaging
 * This is the public Twilio REST API.
 *
 * NOTE: This class is auto generated by OpenAPI Generator.
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
namespace ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1;

use ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException;
use ShopMagicTwilioVendor\Twilio\InstanceResource;
use ShopMagicTwilioVendor\Twilio\Options;
use ShopMagicTwilioVendor\Twilio\Values;
use ShopMagicTwilioVendor\Twilio\Version;
use ShopMagicTwilioVendor\Twilio\Deserialize;
use ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\Service\AlphaSenderList;
use ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\Service\PhoneNumberList;
use ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\Service\UsAppToPersonUsecaseList;
use ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\Service\ChannelSenderList;
use ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\Service\ShortCodeList;
use ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\Service\UsAppToPersonList;
/**
 * @property string|null $sid
 * @property string|null $accountSid
 * @property string|null $friendlyName
 * @property \DateTime|null $dateCreated
 * @property \DateTime|null $dateUpdated
 * @property string|null $inboundRequestUrl
 * @property string|null $inboundMethod
 * @property string|null $fallbackUrl
 * @property string|null $fallbackMethod
 * @property string|null $statusCallback
 * @property bool|null $stickySender
 * @property bool|null $mmsConverter
 * @property bool|null $smartEncoding
 * @property string $scanMessageContent
 * @property bool|null $fallbackToLongCode
 * @property bool|null $areaCodeGeomatch
 * @property bool|null $synchronousValidation
 * @property int|null $validityPeriod
 * @property string|null $url
 * @property array|null $links
 * @property string|null $usecase
 * @property bool|null $usAppToPersonRegistered
 * @property bool|null $useInboundWebhookOnNumber
 */
class ServiceInstance extends \ShopMagicTwilioVendor\Twilio\InstanceResource
{
    protected $_alphaSenders;
    protected $_phoneNumbers;
    protected $_usAppToPersonUsecases;
    protected $_channelSenders;
    protected $_shortCodes;
    protected $_usAppToPerson;
    /**
     * Initialize the ServiceInstance
     *
     * @param Version $version Version that contains the resource
     * @param mixed[] $payload The response payload
     * @param string $sid The SID of the Service resource to delete.
     */
    public function __construct(\ShopMagicTwilioVendor\Twilio\Version $version, array $payload, string $sid = null)
    {
        parent::__construct($version);
        // Marshaled Properties
        $this->properties = ['sid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'sid'), 'accountSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'account_sid'), 'friendlyName' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'friendly_name'), 'dateCreated' => \ShopMagicTwilioVendor\Twilio\Deserialize::dateTime(\ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'date_created')), 'dateUpdated' => \ShopMagicTwilioVendor\Twilio\Deserialize::dateTime(\ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'date_updated')), 'inboundRequestUrl' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'inbound_request_url'), 'inboundMethod' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'inbound_method'), 'fallbackUrl' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'fallback_url'), 'fallbackMethod' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'fallback_method'), 'statusCallback' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'status_callback'), 'stickySender' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'sticky_sender'), 'mmsConverter' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'mms_converter'), 'smartEncoding' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'smart_encoding'), 'scanMessageContent' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'scan_message_content'), 'fallbackToLongCode' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'fallback_to_long_code'), 'areaCodeGeomatch' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'area_code_geomatch'), 'synchronousValidation' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'synchronous_validation'), 'validityPeriod' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'validity_period'), 'url' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'url'), 'links' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'links'), 'usecase' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'usecase'), 'usAppToPersonRegistered' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'us_app_to_person_registered'), 'useInboundWebhookOnNumber' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'use_inbound_webhook_on_number')];
        $this->solution = ['sid' => $sid ?: $this->properties['sid']];
    }
    /**
     * Generate an instance context for the instance, the context is capable of
     * performing various actions.  All instance actions are proxied to the context
     *
     * @return ServiceContext Context for this ServiceInstance
     */
    protected function proxy() : \ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\ServiceContext
    {
        if (!$this->context) {
            $this->context = new \ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\ServiceContext($this->version, $this->solution['sid']);
        }
        return $this->context;
    }
    /**
     * Delete the ServiceInstance
     *
     * @return bool True if delete succeeds, false otherwise
     * @throws TwilioException When an HTTP error occurs.
     */
    public function delete() : bool
    {
        return $this->proxy()->delete();
    }
    /**
     * Fetch the ServiceInstance
     *
     * @return ServiceInstance Fetched ServiceInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function fetch() : \ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\ServiceInstance
    {
        return $this->proxy()->fetch();
    }
    /**
     * Update the ServiceInstance
     *
     * @param array|Options $options Optional Arguments
     * @return ServiceInstance Updated ServiceInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function update(array $options = []) : \ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\ServiceInstance
    {
        return $this->proxy()->update($options);
    }
    /**
     * Access the alphaSenders
     */
    protected function getAlphaSenders() : \ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\Service\AlphaSenderList
    {
        return $this->proxy()->alphaSenders;
    }
    /**
     * Access the phoneNumbers
     */
    protected function getPhoneNumbers() : \ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\Service\PhoneNumberList
    {
        return $this->proxy()->phoneNumbers;
    }
    /**
     * Access the usAppToPersonUsecases
     */
    protected function getUsAppToPersonUsecases() : \ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\Service\UsAppToPersonUsecaseList
    {
        return $this->proxy()->usAppToPersonUsecases;
    }
    /**
     * Access the channelSenders
     */
    protected function getChannelSenders() : \ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\Service\ChannelSenderList
    {
        return $this->proxy()->channelSenders;
    }
    /**
     * Access the shortCodes
     */
    protected function getShortCodes() : \ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\Service\ShortCodeList
    {
        return $this->proxy()->shortCodes;
    }
    /**
     * Access the usAppToPerson
     */
    protected function getUsAppToPerson() : \ShopMagicTwilioVendor\Twilio\Rest\Messaging\V1\Service\UsAppToPersonList
    {
        return $this->proxy()->usAppToPerson;
    }
    /**
     * Magic getter to access properties
     *
     * @param string $name Property to access
     * @return mixed The requested property
     * @throws TwilioException For unknown properties
     */
    public function __get(string $name)
    {
        if (\array_key_exists($name, $this->properties)) {
            return $this->properties[$name];
        }
        if (\property_exists($this, '_' . $name)) {
            $method = 'get' . \ucfirst($name);
            return $this->{$method}();
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Unknown property: ' . $name);
    }
    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString() : string
    {
        $context = [];
        foreach ($this->solution as $key => $value) {
            $context[] = "{$key}={$value}";
        }
        return '[Twilio.Messaging.V1.ServiceInstance ' . \implode(' ', $context) . ']';
    }
}
