<?php

/**
 * This code was generated by
 * ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
 *  |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
 *  |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \
 *
 * Twilio - Microvisor
 * This is the public Twilio REST API.
 *
 * NOTE: This class is auto generated by OpenAPI Generator.
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
namespace ShopMagicTwilioVendor\Twilio\Rest\Microvisor\V1\Device;

use ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException;
use ShopMagicTwilioVendor\Twilio\InstanceResource;
use ShopMagicTwilioVendor\Twilio\Values;
use ShopMagicTwilioVendor\Twilio\Version;
use ShopMagicTwilioVendor\Twilio\Deserialize;
/**
 * @property string|null $deviceSid
 * @property string|null $key
 * @property string|null $value
 * @property \DateTime|null $dateUpdated
 * @property string|null $url
 */
class DeviceConfigInstance extends \ShopMagicTwilioVendor\Twilio\InstanceResource
{
    /**
     * Initialize the DeviceConfigInstance
     *
     * @param Version $version Version that contains the resource
     * @param mixed[] $payload The response payload
     * @param string $deviceSid A 34-character string that uniquely identifies the Device.
     * @param string $key The config key; up to 100 characters.
     */
    public function __construct(\ShopMagicTwilioVendor\Twilio\Version $version, array $payload, string $deviceSid, string $key = null)
    {
        parent::__construct($version);
        // Marshaled Properties
        $this->properties = ['deviceSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'device_sid'), 'key' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'key'), 'value' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'value'), 'dateUpdated' => \ShopMagicTwilioVendor\Twilio\Deserialize::dateTime(\ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'date_updated')), 'url' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'url')];
        $this->solution = ['deviceSid' => $deviceSid, 'key' => $key ?: $this->properties['key']];
    }
    /**
     * Generate an instance context for the instance, the context is capable of
     * performing various actions.  All instance actions are proxied to the context
     *
     * @return DeviceConfigContext Context for this DeviceConfigInstance
     */
    protected function proxy() : \ShopMagicTwilioVendor\Twilio\Rest\Microvisor\V1\Device\DeviceConfigContext
    {
        if (!$this->context) {
            $this->context = new \ShopMagicTwilioVendor\Twilio\Rest\Microvisor\V1\Device\DeviceConfigContext($this->version, $this->solution['deviceSid'], $this->solution['key']);
        }
        return $this->context;
    }
    /**
     * Delete the DeviceConfigInstance
     *
     * @return bool True if delete succeeds, false otherwise
     * @throws TwilioException When an HTTP error occurs.
     */
    public function delete() : bool
    {
        return $this->proxy()->delete();
    }
    /**
     * Fetch the DeviceConfigInstance
     *
     * @return DeviceConfigInstance Fetched DeviceConfigInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function fetch() : \ShopMagicTwilioVendor\Twilio\Rest\Microvisor\V1\Device\DeviceConfigInstance
    {
        return $this->proxy()->fetch();
    }
    /**
     * Update the DeviceConfigInstance
     *
     * @param string $value The config value; up to 4096 characters.
     * @return DeviceConfigInstance Updated DeviceConfigInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function update(string $value) : \ShopMagicTwilioVendor\Twilio\Rest\Microvisor\V1\Device\DeviceConfigInstance
    {
        return $this->proxy()->update($value);
    }
    /**
     * Magic getter to access properties
     *
     * @param string $name Property to access
     * @return mixed The requested property
     * @throws TwilioException For unknown properties
     */
    public function __get(string $name)
    {
        if (\array_key_exists($name, $this->properties)) {
            return $this->properties[$name];
        }
        if (\property_exists($this, '_' . $name)) {
            $method = 'get' . \ucfirst($name);
            return $this->{$method}();
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Unknown property: ' . $name);
    }
    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString() : string
    {
        $context = [];
        foreach ($this->solution as $key => $value) {
            $context[] = "{$key}={$value}";
        }
        return '[Twilio.Microvisor.V1.DeviceConfigInstance ' . \implode(' ', $context) . ']';
    }
}
