<?php

/**
 * This code was generated by
 * ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
 *  |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
 *  |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \
 *
 * Twilio - Numbers
 * This is the public Twilio REST API.
 *
 * NOTE: This class is auto generated by OpenAPI Generator.
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
namespace ShopMagicTwilioVendor\Twilio\Rest\Numbers\V1;

use ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException;
use ShopMagicTwilioVendor\Twilio\ListResource;
use ShopMagicTwilioVendor\Twilio\Values;
use ShopMagicTwilioVendor\Twilio\Version;
use ShopMagicTwilioVendor\Twilio\Serialize;
class PortingBulkPortabilityList extends \ShopMagicTwilioVendor\Twilio\ListResource
{
    /**
     * Construct the PortingBulkPortabilityList
     *
     * @param Version $version Version that contains the resource
     */
    public function __construct(\ShopMagicTwilioVendor\Twilio\Version $version)
    {
        parent::__construct($version);
        // Path Solution
        $this->solution = [];
        $this->uri = '/Porting/Portability';
    }
    /**
     * Create the PortingBulkPortabilityInstance
     *
     * @param string[] $phoneNumbers The phone numbers which portability is to be checked. This should be a list of strings. Phone numbers are in E.164 format (e.g. +16175551212). .
     * @return PortingBulkPortabilityInstance Created PortingBulkPortabilityInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function create(array $phoneNumbers) : \ShopMagicTwilioVendor\Twilio\Rest\Numbers\V1\PortingBulkPortabilityInstance
    {
        $data = \ShopMagicTwilioVendor\Twilio\Values::of(['PhoneNumbers' => \ShopMagicTwilioVendor\Twilio\Serialize::map($phoneNumbers, function ($e) {
            return $e;
        })]);
        $payload = $this->version->create('POST', $this->uri, [], $data);
        return new \ShopMagicTwilioVendor\Twilio\Rest\Numbers\V1\PortingBulkPortabilityInstance($this->version, $payload);
    }
    /**
     * Constructs a PortingBulkPortabilityContext
     *
     * @param string $sid A 34 character string that uniquely identifies the Portability check.
     */
    public function getContext(string $sid) : \ShopMagicTwilioVendor\Twilio\Rest\Numbers\V1\PortingBulkPortabilityContext
    {
        return new \ShopMagicTwilioVendor\Twilio\Rest\Numbers\V1\PortingBulkPortabilityContext($this->version, $sid);
    }
    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString() : string
    {
        return '[Twilio.Numbers.V1.PortingBulkPortabilityList]';
    }
}
