<?php

/**
 * This code was generated by
 * ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
 *  |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
 *  |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \
 *
 * Twilio - Numbers
 * This is the public Twilio REST API.
 *
 * NOTE: This class is auto generated by OpenAPI Generator.
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
namespace ShopMagicTwilioVendor\Twilio\Rest\Numbers\V1;

use ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException;
use ShopMagicTwilioVendor\Twilio\InstanceResource;
use ShopMagicTwilioVendor\Twilio\Options;
use ShopMagicTwilioVendor\Twilio\Values;
use ShopMagicTwilioVendor\Twilio\Version;
/**
 * @property string|null $phoneNumber
 * @property string|null $accountSid
 * @property bool|null $portable
 * @property bool|null $pinAndAccountNumberRequired
 * @property string|null $notPortableReason
 * @property int|null $notPortableReasonCode
 * @property string $numberType
 * @property string|null $country
 * @property string|null $messagingCarrier
 * @property string|null $voiceCarrier
 * @property string|null $url
 */
class PortingPortabilityInstance extends \ShopMagicTwilioVendor\Twilio\InstanceResource
{
    /**
     * Initialize the PortingPortabilityInstance
     *
     * @param Version $version Version that contains the resource
     * @param mixed[] $payload The response payload
     * @param string $phoneNumber The phone number which portability is to be checked. Phone numbers are in E.164 format (e.g. +16175551212).
     */
    public function __construct(\ShopMagicTwilioVendor\Twilio\Version $version, array $payload, string $phoneNumber = null)
    {
        parent::__construct($version);
        // Marshaled Properties
        $this->properties = ['phoneNumber' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'phone_number'), 'accountSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'account_sid'), 'portable' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'portable'), 'pinAndAccountNumberRequired' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'pin_and_account_number_required'), 'notPortableReason' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'not_portable_reason'), 'notPortableReasonCode' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'not_portable_reason_code'), 'numberType' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'number_type'), 'country' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'country'), 'messagingCarrier' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'messaging_carrier'), 'voiceCarrier' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'voice_carrier'), 'url' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'url')];
        $this->solution = ['phoneNumber' => $phoneNumber ?: $this->properties['phoneNumber']];
    }
    /**
     * Generate an instance context for the instance, the context is capable of
     * performing various actions.  All instance actions are proxied to the context
     *
     * @return PortingPortabilityContext Context for this PortingPortabilityInstance
     */
    protected function proxy() : \ShopMagicTwilioVendor\Twilio\Rest\Numbers\V1\PortingPortabilityContext
    {
        if (!$this->context) {
            $this->context = new \ShopMagicTwilioVendor\Twilio\Rest\Numbers\V1\PortingPortabilityContext($this->version, $this->solution['phoneNumber']);
        }
        return $this->context;
    }
    /**
     * Fetch the PortingPortabilityInstance
     *
     * @param array|Options $options Optional Arguments
     * @return PortingPortabilityInstance Fetched PortingPortabilityInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function fetch(array $options = []) : \ShopMagicTwilioVendor\Twilio\Rest\Numbers\V1\PortingPortabilityInstance
    {
        return $this->proxy()->fetch($options);
    }
    /**
     * Magic getter to access properties
     *
     * @param string $name Property to access
     * @return mixed The requested property
     * @throws TwilioException For unknown properties
     */
    public function __get(string $name)
    {
        if (\array_key_exists($name, $this->properties)) {
            return $this->properties[$name];
        }
        if (\property_exists($this, '_' . $name)) {
            $method = 'get' . \ucfirst($name);
            return $this->{$method}();
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Unknown property: ' . $name);
    }
    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString() : string
    {
        $context = [];
        foreach ($this->solution as $key => $value) {
            $context[] = "{$key}={$value}";
        }
        return '[Twilio.Numbers.V1.PortingPortabilityInstance ' . \implode(' ', $context) . ']';
    }
}
