<?php

/**
 * This code was generated by
 * ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
 *  |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
 *  |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \
 *
 * Twilio - Numbers
 * This is the public Twilio REST API.
 *
 * NOTE: This class is auto generated by OpenAPI Generator.
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
namespace ShopMagicTwilioVendor\Twilio\Rest\Numbers\V2;

use ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException;
use ShopMagicTwilioVendor\Twilio\InstanceResource;
use ShopMagicTwilioVendor\Twilio\Values;
use ShopMagicTwilioVendor\Twilio\Version;
use ShopMagicTwilioVendor\Twilio\Deserialize;
use ShopMagicTwilioVendor\Twilio\Base\PhoneNumberCapabilities;
/**
 * @property string|null $sid
 * @property string|null $accountSid
 * @property string|null $incomingPhoneNumberSid
 * @property string|null $addressSid
 * @property string|null $signingDocumentSid
 * @property string|null $phoneNumber
 * @property PhoneNumberCapabilities|null $capabilities
 * @property string|null $friendlyName
 * @property string $status
 * @property string|null $failureReason
 * @property \DateTime|null $dateCreated
 * @property \DateTime|null $dateUpdated
 * @property string|null $email
 * @property string[]|null $ccEmails
 * @property string|null $url
 * @property string|null $contactTitle
 * @property string|null $contactPhoneNumber
 * @property string|null $bulkHostingRequestSid
 * @property string|null $nextStep
 */
class HostedNumberOrderInstance extends \ShopMagicTwilioVendor\Twilio\InstanceResource
{
    /**
     * Initialize the HostedNumberOrderInstance
     *
     * @param Version $version Version that contains the resource
     * @param mixed[] $payload The response payload
     * @param string $sid A 34 character string that uniquely identifies this HostedNumberOrder.
     */
    public function __construct(\ShopMagicTwilioVendor\Twilio\Version $version, array $payload, string $sid = null)
    {
        parent::__construct($version);
        // Marshaled Properties
        $this->properties = ['sid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'sid'), 'accountSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'account_sid'), 'incomingPhoneNumberSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'incoming_phone_number_sid'), 'addressSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'address_sid'), 'signingDocumentSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'signing_document_sid'), 'phoneNumber' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'phone_number'), 'capabilities' => \ShopMagicTwilioVendor\Twilio\Deserialize::phoneNumberCapabilities(\ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'capabilities')), 'friendlyName' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'friendly_name'), 'status' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'status'), 'failureReason' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'failure_reason'), 'dateCreated' => \ShopMagicTwilioVendor\Twilio\Deserialize::dateTime(\ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'date_created')), 'dateUpdated' => \ShopMagicTwilioVendor\Twilio\Deserialize::dateTime(\ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'date_updated')), 'email' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'email'), 'ccEmails' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'cc_emails'), 'url' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'url'), 'contactTitle' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'contact_title'), 'contactPhoneNumber' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'contact_phone_number'), 'bulkHostingRequestSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'bulk_hosting_request_sid'), 'nextStep' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'next_step')];
        $this->solution = ['sid' => $sid ?: $this->properties['sid']];
    }
    /**
     * Generate an instance context for the instance, the context is capable of
     * performing various actions.  All instance actions are proxied to the context
     *
     * @return HostedNumberOrderContext Context for this HostedNumberOrderInstance
     */
    protected function proxy() : \ShopMagicTwilioVendor\Twilio\Rest\Numbers\V2\HostedNumberOrderContext
    {
        if (!$this->context) {
            $this->context = new \ShopMagicTwilioVendor\Twilio\Rest\Numbers\V2\HostedNumberOrderContext($this->version, $this->solution['sid']);
        }
        return $this->context;
    }
    /**
     * Delete the HostedNumberOrderInstance
     *
     * @return bool True if delete succeeds, false otherwise
     * @throws TwilioException When an HTTP error occurs.
     */
    public function delete() : bool
    {
        return $this->proxy()->delete();
    }
    /**
     * Fetch the HostedNumberOrderInstance
     *
     * @return HostedNumberOrderInstance Fetched HostedNumberOrderInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function fetch() : \ShopMagicTwilioVendor\Twilio\Rest\Numbers\V2\HostedNumberOrderInstance
    {
        return $this->proxy()->fetch();
    }
    /**
     * Magic getter to access properties
     *
     * @param string $name Property to access
     * @return mixed The requested property
     * @throws TwilioException For unknown properties
     */
    public function __get(string $name)
    {
        if (\array_key_exists($name, $this->properties)) {
            return $this->properties[$name];
        }
        if (\property_exists($this, '_' . $name)) {
            $method = 'get' . \ucfirst($name);
            return $this->{$method}();
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Unknown property: ' . $name);
    }
    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString() : string
    {
        $context = [];
        foreach ($this->solution as $key => $value) {
            $context[] = "{$key}={$value}";
        }
        return '[Twilio.Numbers.V2.HostedNumberOrderInstance ' . \implode(' ', $context) . ']';
    }
}
