<?php

/**
 * This code was generated by
 * ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
 *  |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
 *  |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \
 *
 * Twilio - Preview
 * This is the public Twilio REST API.
 *
 * NOTE: This class is auto generated by OpenAPI Generator.
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
namespace ShopMagicTwilioVendor\Twilio\Rest\Preview\HostedNumbers\AuthorizationDocument;

use ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException;
use ShopMagicTwilioVendor\Twilio\InstanceResource;
use ShopMagicTwilioVendor\Twilio\Values;
use ShopMagicTwilioVendor\Twilio\Version;
use ShopMagicTwilioVendor\Twilio\Deserialize;
use ShopMagicTwilioVendor\Twilio\Base\PhoneNumberCapabilities;
/**
 * @property string|null $sid
 * @property string|null $accountSid
 * @property string|null $incomingPhoneNumberSid
 * @property string|null $addressSid
 * @property string|null $signingDocumentSid
 * @property string|null $phoneNumber
 * @property PhoneNumberCapabilities|null $capabilities
 * @property string|null $friendlyName
 * @property string|null $uniqueName
 * @property string $status
 * @property string|null $failureReason
 * @property \DateTime|null $dateCreated
 * @property \DateTime|null $dateUpdated
 * @property int|null $verificationAttempts
 * @property string|null $email
 * @property string[]|null $ccEmails
 * @property string $verificationType
 * @property string|null $verificationDocumentSid
 * @property string|null $extension
 * @property int|null $callDelay
 * @property string|null $verificationCode
 * @property string[]|null $verificationCallSids
 */
class DependentHostedNumberOrderInstance extends \ShopMagicTwilioVendor\Twilio\InstanceResource
{
    /**
     * Initialize the DependentHostedNumberOrderInstance
     *
     * @param Version $version Version that contains the resource
     * @param mixed[] $payload The response payload
     * @param string $signingDocumentSid A 34 character string that uniquely identifies the LOA document associated with this HostedNumberOrder.
     */
    public function __construct(\ShopMagicTwilioVendor\Twilio\Version $version, array $payload, string $signingDocumentSid)
    {
        parent::__construct($version);
        // Marshaled Properties
        $this->properties = ['sid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'sid'), 'accountSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'account_sid'), 'incomingPhoneNumberSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'incoming_phone_number_sid'), 'addressSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'address_sid'), 'signingDocumentSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'signing_document_sid'), 'phoneNumber' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'phone_number'), 'capabilities' => \ShopMagicTwilioVendor\Twilio\Deserialize::phoneNumberCapabilities(\ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'capabilities')), 'friendlyName' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'friendly_name'), 'uniqueName' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'unique_name'), 'status' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'status'), 'failureReason' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'failure_reason'), 'dateCreated' => \ShopMagicTwilioVendor\Twilio\Deserialize::dateTime(\ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'date_created')), 'dateUpdated' => \ShopMagicTwilioVendor\Twilio\Deserialize::dateTime(\ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'date_updated')), 'verificationAttempts' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'verification_attempts'), 'email' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'email'), 'ccEmails' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'cc_emails'), 'verificationType' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'verification_type'), 'verificationDocumentSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'verification_document_sid'), 'extension' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'extension'), 'callDelay' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'call_delay'), 'verificationCode' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'verification_code'), 'verificationCallSids' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'verification_call_sids')];
        $this->solution = ['signingDocumentSid' => $signingDocumentSid];
    }
    /**
     * Magic getter to access properties
     *
     * @param string $name Property to access
     * @return mixed The requested property
     * @throws TwilioException For unknown properties
     */
    public function __get(string $name)
    {
        if (\array_key_exists($name, $this->properties)) {
            return $this->properties[$name];
        }
        if (\property_exists($this, '_' . $name)) {
            $method = 'get' . \ucfirst($name);
            return $this->{$method}();
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Unknown property: ' . $name);
    }
    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString() : string
    {
        return '[Twilio.Preview.HostedNumbers.DependentHostedNumberOrderInstance]';
    }
}
