<?php

/**
 * This code was generated by
 * ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
 *  |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
 *  |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \
 *
 * Twilio - Proxy
 * This is the public Twilio REST API.
 *
 * NOTE: This class is auto generated by OpenAPI Generator.
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
namespace ShopMagicTwilioVendor\Twilio\Rest\Proxy\V1\Service\Session;

use ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException;
use ShopMagicTwilioVendor\Twilio\InstanceResource;
use ShopMagicTwilioVendor\Twilio\Values;
use ShopMagicTwilioVendor\Twilio\Version;
use ShopMagicTwilioVendor\Twilio\Deserialize;
/**
 * @property string|null $sid
 * @property string|null $sessionSid
 * @property string|null $serviceSid
 * @property string|null $accountSid
 * @property string|null $data
 * @property string $type
 * @property string|null $inboundParticipantSid
 * @property string|null $inboundResourceSid
 * @property string $inboundResourceStatus
 * @property string|null $inboundResourceType
 * @property string|null $inboundResourceUrl
 * @property string|null $outboundParticipantSid
 * @property string|null $outboundResourceSid
 * @property string $outboundResourceStatus
 * @property string|null $outboundResourceType
 * @property string|null $outboundResourceUrl
 * @property \DateTime|null $dateCreated
 * @property \DateTime|null $dateUpdated
 * @property string|null $url
 */
class InteractionInstance extends \ShopMagicTwilioVendor\Twilio\InstanceResource
{
    /**
     * Initialize the InteractionInstance
     *
     * @param Version $version Version that contains the resource
     * @param mixed[] $payload The response payload
     * @param string $serviceSid The SID of the parent [Service](https://www.twilio.com/docs/proxy/api/service) of the resource to delete.
     * @param string $sessionSid The SID of the parent [Session](https://www.twilio.com/docs/proxy/api/session) of the resource to delete.
     * @param string $sid The Twilio-provided string that uniquely identifies the Interaction resource to delete.
     */
    public function __construct(\ShopMagicTwilioVendor\Twilio\Version $version, array $payload, string $serviceSid, string $sessionSid, string $sid = null)
    {
        parent::__construct($version);
        // Marshaled Properties
        $this->properties = ['sid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'sid'), 'sessionSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'session_sid'), 'serviceSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'service_sid'), 'accountSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'account_sid'), 'data' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'data'), 'type' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'type'), 'inboundParticipantSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'inbound_participant_sid'), 'inboundResourceSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'inbound_resource_sid'), 'inboundResourceStatus' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'inbound_resource_status'), 'inboundResourceType' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'inbound_resource_type'), 'inboundResourceUrl' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'inbound_resource_url'), 'outboundParticipantSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'outbound_participant_sid'), 'outboundResourceSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'outbound_resource_sid'), 'outboundResourceStatus' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'outbound_resource_status'), 'outboundResourceType' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'outbound_resource_type'), 'outboundResourceUrl' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'outbound_resource_url'), 'dateCreated' => \ShopMagicTwilioVendor\Twilio\Deserialize::dateTime(\ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'date_created')), 'dateUpdated' => \ShopMagicTwilioVendor\Twilio\Deserialize::dateTime(\ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'date_updated')), 'url' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'url')];
        $this->solution = ['serviceSid' => $serviceSid, 'sessionSid' => $sessionSid, 'sid' => $sid ?: $this->properties['sid']];
    }
    /**
     * Generate an instance context for the instance, the context is capable of
     * performing various actions.  All instance actions are proxied to the context
     *
     * @return InteractionContext Context for this InteractionInstance
     */
    protected function proxy() : \ShopMagicTwilioVendor\Twilio\Rest\Proxy\V1\Service\Session\InteractionContext
    {
        if (!$this->context) {
            $this->context = new \ShopMagicTwilioVendor\Twilio\Rest\Proxy\V1\Service\Session\InteractionContext($this->version, $this->solution['serviceSid'], $this->solution['sessionSid'], $this->solution['sid']);
        }
        return $this->context;
    }
    /**
     * Delete the InteractionInstance
     *
     * @return bool True if delete succeeds, false otherwise
     * @throws TwilioException When an HTTP error occurs.
     */
    public function delete() : bool
    {
        return $this->proxy()->delete();
    }
    /**
     * Fetch the InteractionInstance
     *
     * @return InteractionInstance Fetched InteractionInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function fetch() : \ShopMagicTwilioVendor\Twilio\Rest\Proxy\V1\Service\Session\InteractionInstance
    {
        return $this->proxy()->fetch();
    }
    /**
     * Magic getter to access properties
     *
     * @param string $name Property to access
     * @return mixed The requested property
     * @throws TwilioException For unknown properties
     */
    public function __get(string $name)
    {
        if (\array_key_exists($name, $this->properties)) {
            return $this->properties[$name];
        }
        if (\property_exists($this, '_' . $name)) {
            $method = 'get' . \ucfirst($name);
            return $this->{$method}();
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Unknown property: ' . $name);
    }
    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString() : string
    {
        $context = [];
        foreach ($this->solution as $key => $value) {
            $context[] = "{$key}={$value}";
        }
        return '[Twilio.Proxy.V1.InteractionInstance ' . \implode(' ', $context) . ']';
    }
}
