<?php

/**
 * This code was generated by
 * ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
 *  |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
 *  |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \
 *
 * Twilio - Serverless
 * This is the public Twilio REST API.
 *
 * NOTE: This class is auto generated by OpenAPI Generator.
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
namespace ShopMagicTwilioVendor\Twilio\Rest\Serverless\V1;

use ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException;
use ShopMagicTwilioVendor\Twilio\ListResource;
use ShopMagicTwilioVendor\Twilio\Options;
use ShopMagicTwilioVendor\Twilio\Values;
use ShopMagicTwilioVendor\Twilio\Version;
use ShopMagicTwilioVendor\Twilio\InstanceContext;
use ShopMagicTwilioVendor\Twilio\Serialize;
use ShopMagicTwilioVendor\Twilio\Rest\Serverless\V1\Service\FunctionList;
use ShopMagicTwilioVendor\Twilio\Rest\Serverless\V1\Service\BuildList;
use ShopMagicTwilioVendor\Twilio\Rest\Serverless\V1\Service\EnvironmentList;
use ShopMagicTwilioVendor\Twilio\Rest\Serverless\V1\Service\AssetList;
/**
 * @property FunctionList $functions
 * @property BuildList $builds
 * @property EnvironmentList $environments
 * @property AssetList $assets
 * @method \Twilio\Rest\Serverless\V1\Service\EnvironmentContext environments(string $sid)
 * @method \Twilio\Rest\Serverless\V1\Service\FunctionContext functions(string $sid)
 * @method \Twilio\Rest\Serverless\V1\Service\BuildContext builds(string $sid)
 * @method \Twilio\Rest\Serverless\V1\Service\AssetContext assets(string $sid)
 */
class ServiceContext extends \ShopMagicTwilioVendor\Twilio\InstanceContext
{
    protected $_functions;
    protected $_builds;
    protected $_environments;
    protected $_assets;
    /**
     * Initialize the ServiceContext
     *
     * @param Version $version Version that contains the resource
     * @param string $sid The `sid` or `unique_name` of the Service resource to delete.
     */
    public function __construct(\ShopMagicTwilioVendor\Twilio\Version $version, $sid)
    {
        parent::__construct($version);
        // Path Solution
        $this->solution = ['sid' => $sid];
        $this->uri = '/Services/' . \rawurlencode($sid) . '';
    }
    /**
     * Delete the ServiceInstance
     *
     * @return bool True if delete succeeds, false otherwise
     * @throws TwilioException When an HTTP error occurs.
     */
    public function delete() : bool
    {
        return $this->version->delete('DELETE', $this->uri);
    }
    /**
     * Fetch the ServiceInstance
     *
     * @return ServiceInstance Fetched ServiceInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function fetch() : \ShopMagicTwilioVendor\Twilio\Rest\Serverless\V1\ServiceInstance
    {
        $payload = $this->version->fetch('GET', $this->uri);
        return new \ShopMagicTwilioVendor\Twilio\Rest\Serverless\V1\ServiceInstance($this->version, $payload, $this->solution['sid']);
    }
    /**
     * Update the ServiceInstance
     *
     * @param array|Options $options Optional Arguments
     * @return ServiceInstance Updated ServiceInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function update(array $options = []) : \ShopMagicTwilioVendor\Twilio\Rest\Serverless\V1\ServiceInstance
    {
        $options = new \ShopMagicTwilioVendor\Twilio\Values($options);
        $data = \ShopMagicTwilioVendor\Twilio\Values::of(['IncludeCredentials' => \ShopMagicTwilioVendor\Twilio\Serialize::booleanToString($options['includeCredentials']), 'FriendlyName' => $options['friendlyName'], 'UiEditable' => \ShopMagicTwilioVendor\Twilio\Serialize::booleanToString($options['uiEditable'])]);
        $payload = $this->version->update('POST', $this->uri, [], $data);
        return new \ShopMagicTwilioVendor\Twilio\Rest\Serverless\V1\ServiceInstance($this->version, $payload, $this->solution['sid']);
    }
    /**
     * Access the functions
     */
    protected function getFunctions() : \ShopMagicTwilioVendor\Twilio\Rest\Serverless\V1\Service\FunctionList
    {
        if (!$this->_functions) {
            $this->_functions = new \ShopMagicTwilioVendor\Twilio\Rest\Serverless\V1\Service\FunctionList($this->version, $this->solution['sid']);
        }
        return $this->_functions;
    }
    /**
     * Access the builds
     */
    protected function getBuilds() : \ShopMagicTwilioVendor\Twilio\Rest\Serverless\V1\Service\BuildList
    {
        if (!$this->_builds) {
            $this->_builds = new \ShopMagicTwilioVendor\Twilio\Rest\Serverless\V1\Service\BuildList($this->version, $this->solution['sid']);
        }
        return $this->_builds;
    }
    /**
     * Access the environments
     */
    protected function getEnvironments() : \ShopMagicTwilioVendor\Twilio\Rest\Serverless\V1\Service\EnvironmentList
    {
        if (!$this->_environments) {
            $this->_environments = new \ShopMagicTwilioVendor\Twilio\Rest\Serverless\V1\Service\EnvironmentList($this->version, $this->solution['sid']);
        }
        return $this->_environments;
    }
    /**
     * Access the assets
     */
    protected function getAssets() : \ShopMagicTwilioVendor\Twilio\Rest\Serverless\V1\Service\AssetList
    {
        if (!$this->_assets) {
            $this->_assets = new \ShopMagicTwilioVendor\Twilio\Rest\Serverless\V1\Service\AssetList($this->version, $this->solution['sid']);
        }
        return $this->_assets;
    }
    /**
     * Magic getter to lazy load subresources
     *
     * @param string $name Subresource to return
     * @return ListResource The requested subresource
     * @throws TwilioException For unknown subresources
     */
    public function __get(string $name) : \ShopMagicTwilioVendor\Twilio\ListResource
    {
        if (\property_exists($this, '_' . $name)) {
            $method = 'get' . \ucfirst($name);
            return $this->{$method}();
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Unknown subresource ' . $name);
    }
    /**
     * Magic caller to get resource contexts
     *
     * @param string $name Resource to return
     * @param array $arguments Context parameters
     * @return InstanceContext The requested resource context
     * @throws TwilioException For unknown resource
     */
    public function __call(string $name, array $arguments) : \ShopMagicTwilioVendor\Twilio\InstanceContext
    {
        $property = $this->{$name};
        if (\method_exists($property, 'getContext')) {
            return \call_user_func_array(array($property, 'getContext'), $arguments);
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Resource does not have a context');
    }
    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString() : string
    {
        $context = [];
        foreach ($this->solution as $key => $value) {
            $context[] = "{$key}={$value}";
        }
        return '[Twilio.Serverless.V1.ServiceContext ' . \implode(' ', $context) . ']';
    }
}
