<?php

/**
 * This code was generated by
 * ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
 *  |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
 *  |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \
 *
 * Twilio - Studio
 * This is the public Twilio REST API.
 *
 * NOTE: This class is auto generated by OpenAPI Generator.
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
namespace ShopMagicTwilioVendor\Twilio\Rest\Studio\V2;

use ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException;
use ShopMagicTwilioVendor\Twilio\ListResource;
use ShopMagicTwilioVendor\Twilio\Options;
use ShopMagicTwilioVendor\Twilio\Values;
use ShopMagicTwilioVendor\Twilio\Version;
use ShopMagicTwilioVendor\Twilio\InstanceContext;
use ShopMagicTwilioVendor\Twilio\Serialize;
use ShopMagicTwilioVendor\Twilio\Rest\Studio\V2\Flow\ExecutionList;
use ShopMagicTwilioVendor\Twilio\Rest\Studio\V2\Flow\FlowRevisionList;
use ShopMagicTwilioVendor\Twilio\Rest\Studio\V2\Flow\FlowTestUserList;
/**
 * @property ExecutionList $executions
 * @property FlowRevisionList $revisions
 * @property FlowTestUserList $testUsers
 * @method \Twilio\Rest\Studio\V2\Flow\ExecutionContext executions(string $sid)
 * @method \Twilio\Rest\Studio\V2\Flow\FlowTestUserContext testUsers()
 * @method \Twilio\Rest\Studio\V2\Flow\FlowRevisionContext revisions(string $revision)
 */
class FlowContext extends \ShopMagicTwilioVendor\Twilio\InstanceContext
{
    protected $_executions;
    protected $_revisions;
    protected $_testUsers;
    /**
     * Initialize the FlowContext
     *
     * @param Version $version Version that contains the resource
     * @param string $sid The SID of the Flow resource to delete.
     */
    public function __construct(\ShopMagicTwilioVendor\Twilio\Version $version, $sid)
    {
        parent::__construct($version);
        // Path Solution
        $this->solution = ['sid' => $sid];
        $this->uri = '/Flows/' . \rawurlencode($sid) . '';
    }
    /**
     * Delete the FlowInstance
     *
     * @return bool True if delete succeeds, false otherwise
     * @throws TwilioException When an HTTP error occurs.
     */
    public function delete() : bool
    {
        return $this->version->delete('DELETE', $this->uri);
    }
    /**
     * Fetch the FlowInstance
     *
     * @return FlowInstance Fetched FlowInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function fetch() : \ShopMagicTwilioVendor\Twilio\Rest\Studio\V2\FlowInstance
    {
        $payload = $this->version->fetch('GET', $this->uri);
        return new \ShopMagicTwilioVendor\Twilio\Rest\Studio\V2\FlowInstance($this->version, $payload, $this->solution['sid']);
    }
    /**
     * Update the FlowInstance
     *
     * @param string $status
     * @param array|Options $options Optional Arguments
     * @return FlowInstance Updated FlowInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function update(string $status, array $options = []) : \ShopMagicTwilioVendor\Twilio\Rest\Studio\V2\FlowInstance
    {
        $options = new \ShopMagicTwilioVendor\Twilio\Values($options);
        $data = \ShopMagicTwilioVendor\Twilio\Values::of(['Status' => $status, 'FriendlyName' => $options['friendlyName'], 'Definition' => \ShopMagicTwilioVendor\Twilio\Serialize::jsonObject($options['definition']), 'CommitMessage' => $options['commitMessage']]);
        $payload = $this->version->update('POST', $this->uri, [], $data);
        return new \ShopMagicTwilioVendor\Twilio\Rest\Studio\V2\FlowInstance($this->version, $payload, $this->solution['sid']);
    }
    /**
     * Access the executions
     */
    protected function getExecutions() : \ShopMagicTwilioVendor\Twilio\Rest\Studio\V2\Flow\ExecutionList
    {
        if (!$this->_executions) {
            $this->_executions = new \ShopMagicTwilioVendor\Twilio\Rest\Studio\V2\Flow\ExecutionList($this->version, $this->solution['sid']);
        }
        return $this->_executions;
    }
    /**
     * Access the revisions
     */
    protected function getRevisions() : \ShopMagicTwilioVendor\Twilio\Rest\Studio\V2\Flow\FlowRevisionList
    {
        if (!$this->_revisions) {
            $this->_revisions = new \ShopMagicTwilioVendor\Twilio\Rest\Studio\V2\Flow\FlowRevisionList($this->version, $this->solution['sid']);
        }
        return $this->_revisions;
    }
    /**
     * Access the testUsers
     */
    protected function getTestUsers() : \ShopMagicTwilioVendor\Twilio\Rest\Studio\V2\Flow\FlowTestUserList
    {
        if (!$this->_testUsers) {
            $this->_testUsers = new \ShopMagicTwilioVendor\Twilio\Rest\Studio\V2\Flow\FlowTestUserList($this->version, $this->solution['sid']);
        }
        return $this->_testUsers;
    }
    /**
     * Magic getter to lazy load subresources
     *
     * @param string $name Subresource to return
     * @return ListResource The requested subresource
     * @throws TwilioException For unknown subresources
     */
    public function __get(string $name) : \ShopMagicTwilioVendor\Twilio\ListResource
    {
        if (\property_exists($this, '_' . $name)) {
            $method = 'get' . \ucfirst($name);
            return $this->{$method}();
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Unknown subresource ' . $name);
    }
    /**
     * Magic caller to get resource contexts
     *
     * @param string $name Resource to return
     * @param array $arguments Context parameters
     * @return InstanceContext The requested resource context
     * @throws TwilioException For unknown resource
     */
    public function __call(string $name, array $arguments) : \ShopMagicTwilioVendor\Twilio\InstanceContext
    {
        $property = $this->{$name};
        if (\method_exists($property, 'getContext')) {
            return \call_user_func_array(array($property, 'getContext'), $arguments);
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Resource does not have a context');
    }
    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString() : string
    {
        $context = [];
        foreach ($this->solution as $key => $value) {
            $context[] = "{$key}={$value}";
        }
        return '[Twilio.Studio.V2.FlowContext ' . \implode(' ', $context) . ']';
    }
}
