<?php

/**
 * This code was generated by
 * ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
 *  |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
 *  |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \
 *
 * Twilio - Taskrouter
 * This is the public Twilio REST API.
 *
 * NOTE: This class is auto generated by OpenAPI Generator.
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
namespace ShopMagicTwilioVendor\Twilio\Rest\Taskrouter\V1;

use ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException;
use ShopMagicTwilioVendor\Twilio\ListResource;
use ShopMagicTwilioVendor\Twilio\Options;
use ShopMagicTwilioVendor\Twilio\Values;
use ShopMagicTwilioVendor\Twilio\Version;
use ShopMagicTwilioVendor\Twilio\InstanceContext;
use ShopMagicTwilioVendor\Twilio\Serialize;
use ShopMagicTwilioVendor\Twilio\Rest\Taskrouter\V1\Workspace\TaskQueueList;
use ShopMagicTwilioVendor\Twilio\Rest\Taskrouter\V1\Workspace\EventList;
use ShopMagicTwilioVendor\Twilio\Rest\Taskrouter\V1\Workspace\TaskChannelList;
use ShopMagicTwilioVendor\Twilio\Rest\Taskrouter\V1\Workspace\ActivityList;
use ShopMagicTwilioVendor\Twilio\Rest\Taskrouter\V1\Workspace\WorkerList;
use ShopMagicTwilioVendor\Twilio\Rest\Taskrouter\V1\Workspace\WorkflowList;
use ShopMagicTwilioVendor\Twilio\Rest\Taskrouter\V1\Workspace\TaskList;
use ShopMagicTwilioVendor\Twilio\Rest\Taskrouter\V1\Workspace\WorkspaceCumulativeStatisticsList;
use ShopMagicTwilioVendor\Twilio\Rest\Taskrouter\V1\Workspace\WorkspaceRealTimeStatisticsList;
use ShopMagicTwilioVendor\Twilio\Rest\Taskrouter\V1\Workspace\WorkspaceStatisticsList;
/**
 * @property TaskQueueList $taskQueues
 * @property EventList $events
 * @property TaskChannelList $taskChannels
 * @property ActivityList $activities
 * @property WorkerList $workers
 * @property WorkflowList $workflows
 * @property TaskList $tasks
 * @property WorkspaceCumulativeStatisticsList $cumulativeStatistics
 * @property WorkspaceRealTimeStatisticsList $realTimeStatistics
 * @property WorkspaceStatisticsList $statistics
 * @method \Twilio\Rest\Taskrouter\V1\Workspace\WorkspaceCumulativeStatisticsContext cumulativeStatistics()
 * @method \Twilio\Rest\Taskrouter\V1\Workspace\TaskQueueContext taskQueues(string $sid)
 * @method \Twilio\Rest\Taskrouter\V1\Workspace\ActivityContext activities(string $sid)
 * @method \Twilio\Rest\Taskrouter\V1\Workspace\WorkspaceRealTimeStatisticsContext realTimeStatistics()
 * @method \Twilio\Rest\Taskrouter\V1\Workspace\TaskContext tasks(string $sid)
 * @method \Twilio\Rest\Taskrouter\V1\Workspace\WorkflowContext workflows(string $sid)
 * @method \Twilio\Rest\Taskrouter\V1\Workspace\EventContext events(string $sid)
 * @method \Twilio\Rest\Taskrouter\V1\Workspace\WorkerContext workers(string $sid)
 * @method \Twilio\Rest\Taskrouter\V1\Workspace\WorkspaceStatisticsContext statistics()
 * @method \Twilio\Rest\Taskrouter\V1\Workspace\TaskChannelContext taskChannels(string $sid)
 */
class WorkspaceContext extends \ShopMagicTwilioVendor\Twilio\InstanceContext
{
    protected $_taskQueues;
    protected $_events;
    protected $_taskChannels;
    protected $_activities;
    protected $_workers;
    protected $_workflows;
    protected $_tasks;
    protected $_cumulativeStatistics;
    protected $_realTimeStatistics;
    protected $_statistics;
    /**
     * Initialize the WorkspaceContext
     *
     * @param Version $version Version that contains the resource
     * @param string $sid The SID of the Workspace resource to delete.
     */
    public function __construct(\ShopMagicTwilioVendor\Twilio\Version $version, $sid)
    {
        parent::__construct($version);
        // Path Solution
        $this->solution = ['sid' => $sid];
        $this->uri = '/Workspaces/' . \rawurlencode($sid) . '';
    }
    /**
     * Delete the WorkspaceInstance
     *
     * @return bool True if delete succeeds, false otherwise
     * @throws TwilioException When an HTTP error occurs.
     */
    public function delete() : bool
    {
        return $this->version->delete('DELETE', $this->uri);
    }
    /**
     * Fetch the WorkspaceInstance
     *
     * @return WorkspaceInstance Fetched WorkspaceInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function fetch() : \ShopMagicTwilioVendor\Twilio\Rest\Taskrouter\V1\WorkspaceInstance
    {
        $payload = $this->version->fetch('GET', $this->uri);
        return new \ShopMagicTwilioVendor\Twilio\Rest\Taskrouter\V1\WorkspaceInstance($this->version, $payload, $this->solution['sid']);
    }
    /**
     * Update the WorkspaceInstance
     *
     * @param array|Options $options Optional Arguments
     * @return WorkspaceInstance Updated WorkspaceInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function update(array $options = []) : \ShopMagicTwilioVendor\Twilio\Rest\Taskrouter\V1\WorkspaceInstance
    {
        $options = new \ShopMagicTwilioVendor\Twilio\Values($options);
        $data = \ShopMagicTwilioVendor\Twilio\Values::of(['DefaultActivitySid' => $options['defaultActivitySid'], 'EventCallbackUrl' => $options['eventCallbackUrl'], 'EventsFilter' => $options['eventsFilter'], 'FriendlyName' => $options['friendlyName'], 'MultiTaskEnabled' => \ShopMagicTwilioVendor\Twilio\Serialize::booleanToString($options['multiTaskEnabled']), 'TimeoutActivitySid' => $options['timeoutActivitySid'], 'PrioritizeQueueOrder' => $options['prioritizeQueueOrder']]);
        $payload = $this->version->update('POST', $this->uri, [], $data);
        return new \ShopMagicTwilioVendor\Twilio\Rest\Taskrouter\V1\WorkspaceInstance($this->version, $payload, $this->solution['sid']);
    }
    /**
     * Access the taskQueues
     */
    protected function getTaskQueues() : \ShopMagicTwilioVendor\Twilio\Rest\Taskrouter\V1\Workspace\TaskQueueList
    {
        if (!$this->_taskQueues) {
            $this->_taskQueues = new \ShopMagicTwilioVendor\Twilio\Rest\Taskrouter\V1\Workspace\TaskQueueList($this->version, $this->solution['sid']);
        }
        return $this->_taskQueues;
    }
    /**
     * Access the events
     */
    protected function getEvents() : \ShopMagicTwilioVendor\Twilio\Rest\Taskrouter\V1\Workspace\EventList
    {
        if (!$this->_events) {
            $this->_events = new \ShopMagicTwilioVendor\Twilio\Rest\Taskrouter\V1\Workspace\EventList($this->version, $this->solution['sid']);
        }
        return $this->_events;
    }
    /**
     * Access the taskChannels
     */
    protected function getTaskChannels() : \ShopMagicTwilioVendor\Twilio\Rest\Taskrouter\V1\Workspace\TaskChannelList
    {
        if (!$this->_taskChannels) {
            $this->_taskChannels = new \ShopMagicTwilioVendor\Twilio\Rest\Taskrouter\V1\Workspace\TaskChannelList($this->version, $this->solution['sid']);
        }
        return $this->_taskChannels;
    }
    /**
     * Access the activities
     */
    protected function getActivities() : \ShopMagicTwilioVendor\Twilio\Rest\Taskrouter\V1\Workspace\ActivityList
    {
        if (!$this->_activities) {
            $this->_activities = new \ShopMagicTwilioVendor\Twilio\Rest\Taskrouter\V1\Workspace\ActivityList($this->version, $this->solution['sid']);
        }
        return $this->_activities;
    }
    /**
     * Access the workers
     */
    protected function getWorkers() : \ShopMagicTwilioVendor\Twilio\Rest\Taskrouter\V1\Workspace\WorkerList
    {
        if (!$this->_workers) {
            $this->_workers = new \ShopMagicTwilioVendor\Twilio\Rest\Taskrouter\V1\Workspace\WorkerList($this->version, $this->solution['sid']);
        }
        return $this->_workers;
    }
    /**
     * Access the workflows
     */
    protected function getWorkflows() : \ShopMagicTwilioVendor\Twilio\Rest\Taskrouter\V1\Workspace\WorkflowList
    {
        if (!$this->_workflows) {
            $this->_workflows = new \ShopMagicTwilioVendor\Twilio\Rest\Taskrouter\V1\Workspace\WorkflowList($this->version, $this->solution['sid']);
        }
        return $this->_workflows;
    }
    /**
     * Access the tasks
     */
    protected function getTasks() : \ShopMagicTwilioVendor\Twilio\Rest\Taskrouter\V1\Workspace\TaskList
    {
        if (!$this->_tasks) {
            $this->_tasks = new \ShopMagicTwilioVendor\Twilio\Rest\Taskrouter\V1\Workspace\TaskList($this->version, $this->solution['sid']);
        }
        return $this->_tasks;
    }
    /**
     * Access the cumulativeStatistics
     */
    protected function getCumulativeStatistics() : \ShopMagicTwilioVendor\Twilio\Rest\Taskrouter\V1\Workspace\WorkspaceCumulativeStatisticsList
    {
        if (!$this->_cumulativeStatistics) {
            $this->_cumulativeStatistics = new \ShopMagicTwilioVendor\Twilio\Rest\Taskrouter\V1\Workspace\WorkspaceCumulativeStatisticsList($this->version, $this->solution['sid']);
        }
        return $this->_cumulativeStatistics;
    }
    /**
     * Access the realTimeStatistics
     */
    protected function getRealTimeStatistics() : \ShopMagicTwilioVendor\Twilio\Rest\Taskrouter\V1\Workspace\WorkspaceRealTimeStatisticsList
    {
        if (!$this->_realTimeStatistics) {
            $this->_realTimeStatistics = new \ShopMagicTwilioVendor\Twilio\Rest\Taskrouter\V1\Workspace\WorkspaceRealTimeStatisticsList($this->version, $this->solution['sid']);
        }
        return $this->_realTimeStatistics;
    }
    /**
     * Access the statistics
     */
    protected function getStatistics() : \ShopMagicTwilioVendor\Twilio\Rest\Taskrouter\V1\Workspace\WorkspaceStatisticsList
    {
        if (!$this->_statistics) {
            $this->_statistics = new \ShopMagicTwilioVendor\Twilio\Rest\Taskrouter\V1\Workspace\WorkspaceStatisticsList($this->version, $this->solution['sid']);
        }
        return $this->_statistics;
    }
    /**
     * Magic getter to lazy load subresources
     *
     * @param string $name Subresource to return
     * @return ListResource The requested subresource
     * @throws TwilioException For unknown subresources
     */
    public function __get(string $name) : \ShopMagicTwilioVendor\Twilio\ListResource
    {
        if (\property_exists($this, '_' . $name)) {
            $method = 'get' . \ucfirst($name);
            return $this->{$method}();
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Unknown subresource ' . $name);
    }
    /**
     * Magic caller to get resource contexts
     *
     * @param string $name Resource to return
     * @param array $arguments Context parameters
     * @return InstanceContext The requested resource context
     * @throws TwilioException For unknown resource
     */
    public function __call(string $name, array $arguments) : \ShopMagicTwilioVendor\Twilio\InstanceContext
    {
        $property = $this->{$name};
        if (\method_exists($property, 'getContext')) {
            return \call_user_func_array(array($property, 'getContext'), $arguments);
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Resource does not have a context');
    }
    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString() : string
    {
        $context = [];
        foreach ($this->solution as $key => $value) {
            $context[] = "{$key}={$value}";
        }
        return '[Twilio.Taskrouter.V1.WorkspaceContext ' . \implode(' ', $context) . ']';
    }
}
