<?php

/**
 * This code was generated by
 * ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
 *  |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
 *  |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \
 *
 * Twilio - Trunking
 * This is the public Twilio REST API.
 *
 * NOTE: This class is auto generated by OpenAPI Generator.
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
namespace ShopMagicTwilioVendor\Twilio\Rest\Trunking\V1;

use ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException;
use ShopMagicTwilioVendor\Twilio\InstanceResource;
use ShopMagicTwilioVendor\Twilio\Options;
use ShopMagicTwilioVendor\Twilio\Values;
use ShopMagicTwilioVendor\Twilio\Version;
use ShopMagicTwilioVendor\Twilio\Deserialize;
use ShopMagicTwilioVendor\Twilio\Rest\Trunking\V1\Trunk\IpAccessControlListList;
use ShopMagicTwilioVendor\Twilio\Rest\Trunking\V1\Trunk\PhoneNumberList;
use ShopMagicTwilioVendor\Twilio\Rest\Trunking\V1\Trunk\CredentialListList;
use ShopMagicTwilioVendor\Twilio\Rest\Trunking\V1\Trunk\OriginationUrlList;
use ShopMagicTwilioVendor\Twilio\Rest\Trunking\V1\Trunk\RecordingList;
/**
 * @property string|null $accountSid
 * @property string|null $domainName
 * @property string|null $disasterRecoveryMethod
 * @property string|null $disasterRecoveryUrl
 * @property string|null $friendlyName
 * @property bool|null $secure
 * @property array|null $recording
 * @property string $transferMode
 * @property string $transferCallerId
 * @property bool|null $cnamLookupEnabled
 * @property string|null $authType
 * @property string[]|null $authTypeSet
 * @property \DateTime|null $dateCreated
 * @property \DateTime|null $dateUpdated
 * @property string|null $sid
 * @property string|null $url
 * @property array|null $links
 */
class TrunkInstance extends \ShopMagicTwilioVendor\Twilio\InstanceResource
{
    protected $_ipAccessControlLists;
    protected $_phoneNumbers;
    protected $_credentialsLists;
    protected $_originationUrls;
    protected $_recordings;
    /**
     * Initialize the TrunkInstance
     *
     * @param Version $version Version that contains the resource
     * @param mixed[] $payload The response payload
     * @param string $sid The unique string that we created to identify the Trunk resource to delete.
     */
    public function __construct(\ShopMagicTwilioVendor\Twilio\Version $version, array $payload, string $sid = null)
    {
        parent::__construct($version);
        // Marshaled Properties
        $this->properties = ['accountSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'account_sid'), 'domainName' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'domain_name'), 'disasterRecoveryMethod' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'disaster_recovery_method'), 'disasterRecoveryUrl' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'disaster_recovery_url'), 'friendlyName' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'friendly_name'), 'secure' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'secure'), 'recording' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'recording'), 'transferMode' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'transfer_mode'), 'transferCallerId' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'transfer_caller_id'), 'cnamLookupEnabled' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'cnam_lookup_enabled'), 'authType' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'auth_type'), 'authTypeSet' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'auth_type_set'), 'dateCreated' => \ShopMagicTwilioVendor\Twilio\Deserialize::dateTime(\ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'date_created')), 'dateUpdated' => \ShopMagicTwilioVendor\Twilio\Deserialize::dateTime(\ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'date_updated')), 'sid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'sid'), 'url' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'url'), 'links' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'links')];
        $this->solution = ['sid' => $sid ?: $this->properties['sid']];
    }
    /**
     * Generate an instance context for the instance, the context is capable of
     * performing various actions.  All instance actions are proxied to the context
     *
     * @return TrunkContext Context for this TrunkInstance
     */
    protected function proxy() : \ShopMagicTwilioVendor\Twilio\Rest\Trunking\V1\TrunkContext
    {
        if (!$this->context) {
            $this->context = new \ShopMagicTwilioVendor\Twilio\Rest\Trunking\V1\TrunkContext($this->version, $this->solution['sid']);
        }
        return $this->context;
    }
    /**
     * Delete the TrunkInstance
     *
     * @return bool True if delete succeeds, false otherwise
     * @throws TwilioException When an HTTP error occurs.
     */
    public function delete() : bool
    {
        return $this->proxy()->delete();
    }
    /**
     * Fetch the TrunkInstance
     *
     * @return TrunkInstance Fetched TrunkInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function fetch() : \ShopMagicTwilioVendor\Twilio\Rest\Trunking\V1\TrunkInstance
    {
        return $this->proxy()->fetch();
    }
    /**
     * Update the TrunkInstance
     *
     * @param array|Options $options Optional Arguments
     * @return TrunkInstance Updated TrunkInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function update(array $options = []) : \ShopMagicTwilioVendor\Twilio\Rest\Trunking\V1\TrunkInstance
    {
        return $this->proxy()->update($options);
    }
    /**
     * Access the ipAccessControlLists
     */
    protected function getIpAccessControlLists() : \ShopMagicTwilioVendor\Twilio\Rest\Trunking\V1\Trunk\IpAccessControlListList
    {
        return $this->proxy()->ipAccessControlLists;
    }
    /**
     * Access the phoneNumbers
     */
    protected function getPhoneNumbers() : \ShopMagicTwilioVendor\Twilio\Rest\Trunking\V1\Trunk\PhoneNumberList
    {
        return $this->proxy()->phoneNumbers;
    }
    /**
     * Access the credentialsLists
     */
    protected function getCredentialsLists() : \ShopMagicTwilioVendor\Twilio\Rest\Trunking\V1\Trunk\CredentialListList
    {
        return $this->proxy()->credentialsLists;
    }
    /**
     * Access the originationUrls
     */
    protected function getOriginationUrls() : \ShopMagicTwilioVendor\Twilio\Rest\Trunking\V1\Trunk\OriginationUrlList
    {
        return $this->proxy()->originationUrls;
    }
    /**
     * Access the recordings
     */
    protected function getRecordings() : \ShopMagicTwilioVendor\Twilio\Rest\Trunking\V1\Trunk\RecordingList
    {
        return $this->proxy()->recordings;
    }
    /**
     * Magic getter to access properties
     *
     * @param string $name Property to access
     * @return mixed The requested property
     * @throws TwilioException For unknown properties
     */
    public function __get(string $name)
    {
        if (\array_key_exists($name, $this->properties)) {
            return $this->properties[$name];
        }
        if (\property_exists($this, '_' . $name)) {
            $method = 'get' . \ucfirst($name);
            return $this->{$method}();
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Unknown property: ' . $name);
    }
    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString() : string
    {
        $context = [];
        foreach ($this->solution as $key => $value) {
            $context[] = "{$key}={$value}";
        }
        return '[Twilio.Trunking.V1.TrunkInstance ' . \implode(' ', $context) . ']';
    }
}
