<?php

/**
 * This code was generated by
 * ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
 *  |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
 *  |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \
 *
 * Twilio - Trusthub
 * This is the public Twilio REST API.
 *
 * NOTE: This class is auto generated by OpenAPI Generator.
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
namespace ShopMagicTwilioVendor\Twilio\Rest\Trusthub\V1;

use ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException;
use ShopMagicTwilioVendor\Twilio\ListResource;
use ShopMagicTwilioVendor\Twilio\Options;
use ShopMagicTwilioVendor\Twilio\Values;
use ShopMagicTwilioVendor\Twilio\Version;
use ShopMagicTwilioVendor\Twilio\InstanceContext;
use ShopMagicTwilioVendor\Twilio\Rest\Trusthub\V1\TrustProducts\TrustProductsChannelEndpointAssignmentList;
use ShopMagicTwilioVendor\Twilio\Rest\Trusthub\V1\TrustProducts\TrustProductsEvaluationsList;
use ShopMagicTwilioVendor\Twilio\Rest\Trusthub\V1\TrustProducts\TrustProductsEntityAssignmentsList;
/**
 * @property TrustProductsChannelEndpointAssignmentList $trustProductsChannelEndpointAssignment
 * @property TrustProductsEvaluationsList $trustProductsEvaluations
 * @property TrustProductsEntityAssignmentsList $trustProductsEntityAssignments
 * @method \Twilio\Rest\Trusthub\V1\TrustProducts\TrustProductsChannelEndpointAssignmentContext trustProductsChannelEndpointAssignment(string $sid)
 * @method \Twilio\Rest\Trusthub\V1\TrustProducts\TrustProductsEntityAssignmentsContext trustProductsEntityAssignments(string $sid)
 * @method \Twilio\Rest\Trusthub\V1\TrustProducts\TrustProductsEvaluationsContext trustProductsEvaluations(string $sid)
 */
class TrustProductsContext extends \ShopMagicTwilioVendor\Twilio\InstanceContext
{
    protected $_trustProductsChannelEndpointAssignment;
    protected $_trustProductsEvaluations;
    protected $_trustProductsEntityAssignments;
    /**
     * Initialize the TrustProductsContext
     *
     * @param Version $version Version that contains the resource
     * @param string $sid The unique string that we created to identify the Customer-Profile resource.
     */
    public function __construct(\ShopMagicTwilioVendor\Twilio\Version $version, $sid)
    {
        parent::__construct($version);
        // Path Solution
        $this->solution = ['sid' => $sid];
        $this->uri = '/TrustProducts/' . \rawurlencode($sid) . '';
    }
    /**
     * Delete the TrustProductsInstance
     *
     * @return bool True if delete succeeds, false otherwise
     * @throws TwilioException When an HTTP error occurs.
     */
    public function delete() : bool
    {
        return $this->version->delete('DELETE', $this->uri);
    }
    /**
     * Fetch the TrustProductsInstance
     *
     * @return TrustProductsInstance Fetched TrustProductsInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function fetch() : \ShopMagicTwilioVendor\Twilio\Rest\Trusthub\V1\TrustProductsInstance
    {
        $payload = $this->version->fetch('GET', $this->uri);
        return new \ShopMagicTwilioVendor\Twilio\Rest\Trusthub\V1\TrustProductsInstance($this->version, $payload, $this->solution['sid']);
    }
    /**
     * Update the TrustProductsInstance
     *
     * @param array|Options $options Optional Arguments
     * @return TrustProductsInstance Updated TrustProductsInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function update(array $options = []) : \ShopMagicTwilioVendor\Twilio\Rest\Trusthub\V1\TrustProductsInstance
    {
        $options = new \ShopMagicTwilioVendor\Twilio\Values($options);
        $data = \ShopMagicTwilioVendor\Twilio\Values::of(['Status' => $options['status'], 'StatusCallback' => $options['statusCallback'], 'FriendlyName' => $options['friendlyName'], 'Email' => $options['email']]);
        $payload = $this->version->update('POST', $this->uri, [], $data);
        return new \ShopMagicTwilioVendor\Twilio\Rest\Trusthub\V1\TrustProductsInstance($this->version, $payload, $this->solution['sid']);
    }
    /**
     * Access the trustProductsChannelEndpointAssignment
     */
    protected function getTrustProductsChannelEndpointAssignment() : \ShopMagicTwilioVendor\Twilio\Rest\Trusthub\V1\TrustProducts\TrustProductsChannelEndpointAssignmentList
    {
        if (!$this->_trustProductsChannelEndpointAssignment) {
            $this->_trustProductsChannelEndpointAssignment = new \ShopMagicTwilioVendor\Twilio\Rest\Trusthub\V1\TrustProducts\TrustProductsChannelEndpointAssignmentList($this->version, $this->solution['sid']);
        }
        return $this->_trustProductsChannelEndpointAssignment;
    }
    /**
     * Access the trustProductsEvaluations
     */
    protected function getTrustProductsEvaluations() : \ShopMagicTwilioVendor\Twilio\Rest\Trusthub\V1\TrustProducts\TrustProductsEvaluationsList
    {
        if (!$this->_trustProductsEvaluations) {
            $this->_trustProductsEvaluations = new \ShopMagicTwilioVendor\Twilio\Rest\Trusthub\V1\TrustProducts\TrustProductsEvaluationsList($this->version, $this->solution['sid']);
        }
        return $this->_trustProductsEvaluations;
    }
    /**
     * Access the trustProductsEntityAssignments
     */
    protected function getTrustProductsEntityAssignments() : \ShopMagicTwilioVendor\Twilio\Rest\Trusthub\V1\TrustProducts\TrustProductsEntityAssignmentsList
    {
        if (!$this->_trustProductsEntityAssignments) {
            $this->_trustProductsEntityAssignments = new \ShopMagicTwilioVendor\Twilio\Rest\Trusthub\V1\TrustProducts\TrustProductsEntityAssignmentsList($this->version, $this->solution['sid']);
        }
        return $this->_trustProductsEntityAssignments;
    }
    /**
     * Magic getter to lazy load subresources
     *
     * @param string $name Subresource to return
     * @return ListResource The requested subresource
     * @throws TwilioException For unknown subresources
     */
    public function __get(string $name) : \ShopMagicTwilioVendor\Twilio\ListResource
    {
        if (\property_exists($this, '_' . $name)) {
            $method = 'get' . \ucfirst($name);
            return $this->{$method}();
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Unknown subresource ' . $name);
    }
    /**
     * Magic caller to get resource contexts
     *
     * @param string $name Resource to return
     * @param array $arguments Context parameters
     * @return InstanceContext The requested resource context
     * @throws TwilioException For unknown resource
     */
    public function __call(string $name, array $arguments) : \ShopMagicTwilioVendor\Twilio\InstanceContext
    {
        $property = $this->{$name};
        if (\method_exists($property, 'getContext')) {
            return \call_user_func_array(array($property, 'getContext'), $arguments);
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Resource does not have a context');
    }
    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString() : string
    {
        $context = [];
        foreach ($this->solution as $key => $value) {
            $context[] = "{$key}={$value}";
        }
        return '[Twilio.Trusthub.V1.TrustProductsContext ' . \implode(' ', $context) . ']';
    }
}
