<?php

/**
 * This code was generated by
 * ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
 *  |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
 *  |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \
 *
 * Twilio - Verify
 * This is the public Twilio REST API.
 *
 * NOTE: This class is auto generated by OpenAPI Generator.
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
namespace ShopMagicTwilioVendor\Twilio\Rest\Verify\V2;

use ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException;
use ShopMagicTwilioVendor\Twilio\InstanceResource;
use ShopMagicTwilioVendor\Twilio\Options;
use ShopMagicTwilioVendor\Twilio\Values;
use ShopMagicTwilioVendor\Twilio\Version;
use ShopMagicTwilioVendor\Twilio\Deserialize;
use ShopMagicTwilioVendor\Twilio\Rest\Verify\V2\Service\EntityList;
use ShopMagicTwilioVendor\Twilio\Rest\Verify\V2\Service\VerificationCheckList;
use ShopMagicTwilioVendor\Twilio\Rest\Verify\V2\Service\VerificationList;
use ShopMagicTwilioVendor\Twilio\Rest\Verify\V2\Service\AccessTokenList;
use ShopMagicTwilioVendor\Twilio\Rest\Verify\V2\Service\RateLimitList;
use ShopMagicTwilioVendor\Twilio\Rest\Verify\V2\Service\WebhookList;
use ShopMagicTwilioVendor\Twilio\Rest\Verify\V2\Service\MessagingConfigurationList;
/**
 * @property string|null $sid
 * @property string|null $accountSid
 * @property string|null $friendlyName
 * @property int|null $codeLength
 * @property bool|null $lookupEnabled
 * @property bool|null $psd2Enabled
 * @property bool|null $skipSmsToLandlines
 * @property bool|null $dtmfInputRequired
 * @property string|null $ttsName
 * @property bool|null $doNotShareWarningEnabled
 * @property bool|null $customCodeEnabled
 * @property array|null $push
 * @property array|null $totp
 * @property string|null $defaultTemplateSid
 * @property bool|null $verifyEventSubscriptionEnabled
 * @property \DateTime|null $dateCreated
 * @property \DateTime|null $dateUpdated
 * @property string|null $url
 * @property array|null $links
 */
class ServiceInstance extends \ShopMagicTwilioVendor\Twilio\InstanceResource
{
    protected $_entities;
    protected $_verificationChecks;
    protected $_verifications;
    protected $_accessTokens;
    protected $_rateLimits;
    protected $_webhooks;
    protected $_messagingConfigurations;
    /**
     * Initialize the ServiceInstance
     *
     * @param Version $version Version that contains the resource
     * @param mixed[] $payload The response payload
     * @param string $sid The Twilio-provided string that uniquely identifies the Verification Service resource to delete.
     */
    public function __construct(\ShopMagicTwilioVendor\Twilio\Version $version, array $payload, string $sid = null)
    {
        parent::__construct($version);
        // Marshaled Properties
        $this->properties = ['sid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'sid'), 'accountSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'account_sid'), 'friendlyName' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'friendly_name'), 'codeLength' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'code_length'), 'lookupEnabled' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'lookup_enabled'), 'psd2Enabled' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'psd2_enabled'), 'skipSmsToLandlines' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'skip_sms_to_landlines'), 'dtmfInputRequired' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'dtmf_input_required'), 'ttsName' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'tts_name'), 'doNotShareWarningEnabled' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'do_not_share_warning_enabled'), 'customCodeEnabled' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'custom_code_enabled'), 'push' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'push'), 'totp' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'totp'), 'defaultTemplateSid' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'default_template_sid'), 'verifyEventSubscriptionEnabled' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'verify_event_subscription_enabled'), 'dateCreated' => \ShopMagicTwilioVendor\Twilio\Deserialize::dateTime(\ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'date_created')), 'dateUpdated' => \ShopMagicTwilioVendor\Twilio\Deserialize::dateTime(\ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'date_updated')), 'url' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'url'), 'links' => \ShopMagicTwilioVendor\Twilio\Values::array_get($payload, 'links')];
        $this->solution = ['sid' => $sid ?: $this->properties['sid']];
    }
    /**
     * Generate an instance context for the instance, the context is capable of
     * performing various actions.  All instance actions are proxied to the context
     *
     * @return ServiceContext Context for this ServiceInstance
     */
    protected function proxy() : \ShopMagicTwilioVendor\Twilio\Rest\Verify\V2\ServiceContext
    {
        if (!$this->context) {
            $this->context = new \ShopMagicTwilioVendor\Twilio\Rest\Verify\V2\ServiceContext($this->version, $this->solution['sid']);
        }
        return $this->context;
    }
    /**
     * Delete the ServiceInstance
     *
     * @return bool True if delete succeeds, false otherwise
     * @throws TwilioException When an HTTP error occurs.
     */
    public function delete() : bool
    {
        return $this->proxy()->delete();
    }
    /**
     * Fetch the ServiceInstance
     *
     * @return ServiceInstance Fetched ServiceInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function fetch() : \ShopMagicTwilioVendor\Twilio\Rest\Verify\V2\ServiceInstance
    {
        return $this->proxy()->fetch();
    }
    /**
     * Update the ServiceInstance
     *
     * @param array|Options $options Optional Arguments
     * @return ServiceInstance Updated ServiceInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function update(array $options = []) : \ShopMagicTwilioVendor\Twilio\Rest\Verify\V2\ServiceInstance
    {
        return $this->proxy()->update($options);
    }
    /**
     * Access the entities
     */
    protected function getEntities() : \ShopMagicTwilioVendor\Twilio\Rest\Verify\V2\Service\EntityList
    {
        return $this->proxy()->entities;
    }
    /**
     * Access the verificationChecks
     */
    protected function getVerificationChecks() : \ShopMagicTwilioVendor\Twilio\Rest\Verify\V2\Service\VerificationCheckList
    {
        return $this->proxy()->verificationChecks;
    }
    /**
     * Access the verifications
     */
    protected function getVerifications() : \ShopMagicTwilioVendor\Twilio\Rest\Verify\V2\Service\VerificationList
    {
        return $this->proxy()->verifications;
    }
    /**
     * Access the accessTokens
     */
    protected function getAccessTokens() : \ShopMagicTwilioVendor\Twilio\Rest\Verify\V2\Service\AccessTokenList
    {
        return $this->proxy()->accessTokens;
    }
    /**
     * Access the rateLimits
     */
    protected function getRateLimits() : \ShopMagicTwilioVendor\Twilio\Rest\Verify\V2\Service\RateLimitList
    {
        return $this->proxy()->rateLimits;
    }
    /**
     * Access the webhooks
     */
    protected function getWebhooks() : \ShopMagicTwilioVendor\Twilio\Rest\Verify\V2\Service\WebhookList
    {
        return $this->proxy()->webhooks;
    }
    /**
     * Access the messagingConfigurations
     */
    protected function getMessagingConfigurations() : \ShopMagicTwilioVendor\Twilio\Rest\Verify\V2\Service\MessagingConfigurationList
    {
        return $this->proxy()->messagingConfigurations;
    }
    /**
     * Magic getter to access properties
     *
     * @param string $name Property to access
     * @return mixed The requested property
     * @throws TwilioException For unknown properties
     */
    public function __get(string $name)
    {
        if (\array_key_exists($name, $this->properties)) {
            return $this->properties[$name];
        }
        if (\property_exists($this, '_' . $name)) {
            $method = 'get' . \ucfirst($name);
            return $this->{$method}();
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Unknown property: ' . $name);
    }
    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString() : string
    {
        $context = [];
        foreach ($this->solution as $key => $value) {
            $context[] = "{$key}={$value}";
        }
        return '[Twilio.Verify.V2.ServiceInstance ' . \implode(' ', $context) . ']';
    }
}
