<?php

/**
 * This code was generated by
 * ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
 *  |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
 *  |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \
 *
 * Twilio - Video
 * This is the public Twilio REST API.
 *
 * NOTE: This class is auto generated by OpenAPI Generator.
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
namespace ShopMagicTwilioVendor\Twilio\Rest\Video;

use ShopMagicTwilioVendor\Twilio\Domain;
use ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException;
use ShopMagicTwilioVendor\Twilio\InstanceContext;
use ShopMagicTwilioVendor\Twilio\Rest\Video\V1\CompositionList;
use ShopMagicTwilioVendor\Twilio\Rest\Video\V1\CompositionHookList;
use ShopMagicTwilioVendor\Twilio\Rest\Video\V1\CompositionSettingsList;
use ShopMagicTwilioVendor\Twilio\Rest\Video\V1\RecordingList;
use ShopMagicTwilioVendor\Twilio\Rest\Video\V1\RecordingSettingsList;
use ShopMagicTwilioVendor\Twilio\Rest\Video\V1\RoomList;
use ShopMagicTwilioVendor\Twilio\Version;
/**
 * @property CompositionList $compositions
 * @property CompositionHookList $compositionHooks
 * @property CompositionSettingsList $compositionSettings
 * @property RecordingList $recordings
 * @property RecordingSettingsList $recordingSettings
 * @property RoomList $rooms
 * @method \Twilio\Rest\Video\V1\CompositionContext compositions(string $sid)
 * @method \Twilio\Rest\Video\V1\CompositionHookContext compositionHooks(string $sid)
 * @method \Twilio\Rest\Video\V1\RecordingContext recordings(string $sid)
 * @method \Twilio\Rest\Video\V1\RoomContext rooms(string $sid)
 */
class V1 extends \ShopMagicTwilioVendor\Twilio\Version
{
    protected $_compositions;
    protected $_compositionHooks;
    protected $_compositionSettings;
    protected $_recordings;
    protected $_recordingSettings;
    protected $_rooms;
    /**
     * Construct the V1 version of Video
     *
     * @param Domain $domain Domain that contains the version
     */
    public function __construct(\ShopMagicTwilioVendor\Twilio\Domain $domain)
    {
        parent::__construct($domain);
        $this->version = 'v1';
    }
    protected function getCompositions() : \ShopMagicTwilioVendor\Twilio\Rest\Video\V1\CompositionList
    {
        if (!$this->_compositions) {
            $this->_compositions = new \ShopMagicTwilioVendor\Twilio\Rest\Video\V1\CompositionList($this);
        }
        return $this->_compositions;
    }
    protected function getCompositionHooks() : \ShopMagicTwilioVendor\Twilio\Rest\Video\V1\CompositionHookList
    {
        if (!$this->_compositionHooks) {
            $this->_compositionHooks = new \ShopMagicTwilioVendor\Twilio\Rest\Video\V1\CompositionHookList($this);
        }
        return $this->_compositionHooks;
    }
    protected function getCompositionSettings() : \ShopMagicTwilioVendor\Twilio\Rest\Video\V1\CompositionSettingsList
    {
        if (!$this->_compositionSettings) {
            $this->_compositionSettings = new \ShopMagicTwilioVendor\Twilio\Rest\Video\V1\CompositionSettingsList($this);
        }
        return $this->_compositionSettings;
    }
    protected function getRecordings() : \ShopMagicTwilioVendor\Twilio\Rest\Video\V1\RecordingList
    {
        if (!$this->_recordings) {
            $this->_recordings = new \ShopMagicTwilioVendor\Twilio\Rest\Video\V1\RecordingList($this);
        }
        return $this->_recordings;
    }
    protected function getRecordingSettings() : \ShopMagicTwilioVendor\Twilio\Rest\Video\V1\RecordingSettingsList
    {
        if (!$this->_recordingSettings) {
            $this->_recordingSettings = new \ShopMagicTwilioVendor\Twilio\Rest\Video\V1\RecordingSettingsList($this);
        }
        return $this->_recordingSettings;
    }
    protected function getRooms() : \ShopMagicTwilioVendor\Twilio\Rest\Video\V1\RoomList
    {
        if (!$this->_rooms) {
            $this->_rooms = new \ShopMagicTwilioVendor\Twilio\Rest\Video\V1\RoomList($this);
        }
        return $this->_rooms;
    }
    /**
     * Magic getter to lazy load root resources
     *
     * @param string $name Resource to return
     * @return \Twilio\ListResource The requested resource
     * @throws TwilioException For unknown resource
     */
    public function __get(string $name)
    {
        $method = 'get' . \ucfirst($name);
        if (\method_exists($this, $method)) {
            return $this->{$method}();
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Unknown resource ' . $name);
    }
    /**
     * Magic caller to get resource contexts
     *
     * @param string $name Resource to return
     * @param array $arguments Context parameters
     * @return InstanceContext The requested resource context
     * @throws TwilioException For unknown resource
     */
    public function __call(string $name, array $arguments) : \ShopMagicTwilioVendor\Twilio\InstanceContext
    {
        $property = $this->{$name};
        if (\method_exists($property, 'getContext')) {
            return \call_user_func_array(array($property, 'getContext'), $arguments);
        }
        throw new \ShopMagicTwilioVendor\Twilio\Exceptions\TwilioException('Resource does not have a context');
    }
    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString() : string
    {
        return '[Twilio.Video.V1]';
    }
}
