<?php

/**
 * This code was generated by
 * \ / _    _  _|   _  _
 * | (_)\/(_)(_|\/| |(/_  v1.0.0
 * /       /
 */
namespace ShopMagicTwilioVendor\Twilio\TwiML\Voice;

use ShopMagicTwilioVendor\Twilio\TwiML\TwiML;
class Say extends \ShopMagicTwilioVendor\Twilio\TwiML\TwiML
{
    /**
     * Say constructor.
     *
     * @param string $message Message to say
     * @param array $attributes Optional attributes
     */
    public function __construct($message, $attributes = [])
    {
        parent::__construct('Say', $message, $attributes);
    }
    /**
     * Add Break child.
     *
     * @param array $attributes Optional attributes
     * @return SsmlBreak Child element.
     */
    public function break_($attributes = []) : \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlBreak
    {
        return $this->nest(new \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlBreak($attributes));
    }
    /**
     * Add Emphasis child.
     *
     * @param string $words Words to emphasize
     * @param array $attributes Optional attributes
     * @return SsmlEmphasis Child element.
     */
    public function emphasis($words, $attributes = []) : \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlEmphasis
    {
        return $this->nest(new \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlEmphasis($words, $attributes));
    }
    /**
     * Add Lang child.
     *
     * @param string $words Words to speak
     * @param array $attributes Optional attributes
     * @return SsmlLang Child element.
     */
    public function lang($words, $attributes = []) : \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlLang
    {
        return $this->nest(new \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlLang($words, $attributes));
    }
    /**
     * Add P child.
     *
     * @param string $words Words to speak
     * @return SsmlP Child element.
     */
    public function p($words) : \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlP
    {
        return $this->nest(new \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlP($words));
    }
    /**
     * Add Phoneme child.
     *
     * @param string $words Words to speak
     * @param array $attributes Optional attributes
     * @return SsmlPhoneme Child element.
     */
    public function phoneme($words, $attributes = []) : \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlPhoneme
    {
        return $this->nest(new \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlPhoneme($words, $attributes));
    }
    /**
     * Add Prosody child.
     *
     * @param string $words Words to speak
     * @param array $attributes Optional attributes
     * @return SsmlProsody Child element.
     */
    public function prosody($words, $attributes = []) : \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlProsody
    {
        return $this->nest(new \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlProsody($words, $attributes));
    }
    /**
     * Add S child.
     *
     * @param string $words Words to speak
     * @return SsmlS Child element.
     */
    public function s($words) : \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlS
    {
        return $this->nest(new \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlS($words));
    }
    /**
     * Add Say-As child.
     *
     * @param string $words Words to be interpreted
     * @param array $attributes Optional attributes
     * @return SsmlSayAs Child element.
     */
    public function say_As($words, $attributes = []) : \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlSayAs
    {
        return $this->nest(new \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlSayAs($words, $attributes));
    }
    /**
     * Add Sub child.
     *
     * @param string $words Words to be substituted
     * @param array $attributes Optional attributes
     * @return SsmlSub Child element.
     */
    public function sub($words, $attributes = []) : \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlSub
    {
        return $this->nest(new \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlSub($words, $attributes));
    }
    /**
     * Add W child.
     *
     * @param string $words Words to speak
     * @param array $attributes Optional attributes
     * @return SsmlW Child element.
     */
    public function w($words, $attributes = []) : \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlW
    {
        return $this->nest(new \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlW($words, $attributes));
    }
    /**
     * Add Voice attribute.
     *
     * @param string $voice Voice to use
     */
    public function setVoice($voice) : self
    {
        return $this->setAttribute('voice', $voice);
    }
    /**
     * Add Loop attribute.
     *
     * @param int $loop Times to loop message
     */
    public function setLoop($loop) : self
    {
        return $this->setAttribute('loop', $loop);
    }
    /**
     * Add Language attribute.
     *
     * @param string $language Message language
     */
    public function setLanguage($language) : self
    {
        return $this->setAttribute('language', $language);
    }
}
