<?php

/**
 * This code was generated by
 * \ / _    _  _|   _  _
 * | (_)\/(_)(_|\/| |(/_  v1.0.0
 * /       /
 */
namespace ShopMagicTwilioVendor\Twilio\TwiML\Voice;

use ShopMagicTwilioVendor\Twilio\TwiML\TwiML;
class SsmlProsody extends \ShopMagicTwilioVendor\Twilio\TwiML\TwiML
{
    /**
     * SsmlProsody constructor.
     *
     * @param string $words Words to speak
     * @param array $attributes Optional attributes
     */
    public function __construct($words, $attributes = [])
    {
        parent::__construct('prosody', $words, $attributes);
    }
    /**
     * Add Break child.
     *
     * @param array $attributes Optional attributes
     * @return SsmlBreak Child element.
     */
    public function break_($attributes = []) : \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlBreak
    {
        return $this->nest(new \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlBreak($attributes));
    }
    /**
     * Add Emphasis child.
     *
     * @param string $words Words to emphasize
     * @param array $attributes Optional attributes
     * @return SsmlEmphasis Child element.
     */
    public function emphasis($words, $attributes = []) : \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlEmphasis
    {
        return $this->nest(new \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlEmphasis($words, $attributes));
    }
    /**
     * Add Lang child.
     *
     * @param string $words Words to speak
     * @param array $attributes Optional attributes
     * @return SsmlLang Child element.
     */
    public function lang($words, $attributes = []) : \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlLang
    {
        return $this->nest(new \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlLang($words, $attributes));
    }
    /**
     * Add P child.
     *
     * @param string $words Words to speak
     * @return SsmlP Child element.
     */
    public function p($words) : \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlP
    {
        return $this->nest(new \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlP($words));
    }
    /**
     * Add Phoneme child.
     *
     * @param string $words Words to speak
     * @param array $attributes Optional attributes
     * @return SsmlPhoneme Child element.
     */
    public function phoneme($words, $attributes = []) : \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlPhoneme
    {
        return $this->nest(new \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlPhoneme($words, $attributes));
    }
    /**
     * Add Prosody child.
     *
     * @param string $words Words to speak
     * @param array $attributes Optional attributes
     * @return SsmlProsody Child element.
     */
    public function prosody($words, $attributes = []) : \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlProsody
    {
        return $this->nest(new \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlProsody($words, $attributes));
    }
    /**
     * Add S child.
     *
     * @param string $words Words to speak
     * @return SsmlS Child element.
     */
    public function s($words) : \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlS
    {
        return $this->nest(new \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlS($words));
    }
    /**
     * Add Say-As child.
     *
     * @param string $words Words to be interpreted
     * @param array $attributes Optional attributes
     * @return SsmlSayAs Child element.
     */
    public function say_As($words, $attributes = []) : \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlSayAs
    {
        return $this->nest(new \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlSayAs($words, $attributes));
    }
    /**
     * Add Sub child.
     *
     * @param string $words Words to be substituted
     * @param array $attributes Optional attributes
     * @return SsmlSub Child element.
     */
    public function sub($words, $attributes = []) : \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlSub
    {
        return $this->nest(new \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlSub($words, $attributes));
    }
    /**
     * Add W child.
     *
     * @param string $words Words to speak
     * @param array $attributes Optional attributes
     * @return SsmlW Child element.
     */
    public function w($words, $attributes = []) : \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlW
    {
        return $this->nest(new \ShopMagicTwilioVendor\Twilio\TwiML\Voice\SsmlW($words, $attributes));
    }
    /**
     * Add Volume attribute.
     *
     * @param string $volume Specify the volume, available values: default, silent,
     *                       x-soft, soft, medium, loud, x-loud, +ndB, -ndB
     */
    public function setVolume($volume) : self
    {
        return $this->setAttribute('volume', $volume);
    }
    /**
     * Add Rate attribute.
     *
     * @param string $rate Specify the rate, available values: x-slow, slow,
     *                     medium, fast, x-fast, n%
     */
    public function setRate($rate) : self
    {
        return $this->setAttribute('rate', $rate);
    }
    /**
     * Add Pitch attribute.
     *
     * @param string $pitch Specify the pitch, available values: default, x-low,
     *                      low, medium, high, x-high, +n%, -n%
     */
    public function setPitch($pitch) : self
    {
        return $this->setAttribute('pitch', $pitch);
    }
}
